/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.40.0-dev.20230617(d514ddaa8d0ac3a3c11bffe6d3ca1bf9ee822228)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(O){for(var n=[],E=0,D=O.length;E<D;E++)n[E]=Z[O[E]];return n};const Ee=this,Re=typeof global=="object"?global:{};var le;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(le||(le={}));var le;(function(O){class n{constructor(o,m,L){this.type=o,this.detail=m,this.timestamp=L}}O.LoaderEvent=n;class E{constructor(o){this._events=[new n(1,"",o)]}record(o,m){this._events.push(new n(o,m,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=E;class D{record(o,m){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(le||(le={}));var le;(function(O){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let o;for(o in D)D.hasOwnProperty(o)&&i(o,D[o])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(o,m)=>{m&&typeof m=="object"?i[o]=n.recursiveClone(m):i[o]=m}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(le||(le={}));var le;(function(O){function n(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}O.ensureError=n;class E{static validateConfigurationOptions(o){function m(L){if(L.phase==="loading"){console.error('Loading "'+L.moduleId+'" failed'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}if(L.phase==="factory"){console.error('The factory function of "'+L.moduleId+'" has thrown an exception'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=m),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(O.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const L=n(new Error("INVALID cached data configuration, 'path' MUST be set"));L.phase="configuration",o.onError(L),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,m=null){let L=O.Utilities.recursiveClone(m||{});return O.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof L.ignoreDuplicateModules<"u"?L.ignoreDuplicateModules=L.ignoreDuplicateModules.concat(s):a==="paths"&&typeof L.paths<"u"?O.Utilities.forEachProperty(s,(_,e)=>L.paths[_]=e):a==="config"&&typeof L.config<"u"?O.Utilities.forEachProperty(s,(_,e)=>L.config[_]=e):L[a]=O.Utilities.recursiveClone(s)}),E.validateConfigurationOptions(L)}}O.ConfigurationOptionsUtil=E;class D{constructor(o,m){if(this._env=o,this.options=E.mergeConfigurationOptions(m),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let L=this.options.nodeRequire.main.filename,a=Math.max(L.lastIndexOf("/"),L.lastIndexOf("\\"));this.options.baseUrl=L.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(o,m)=>{Array.isArray(m)?this.sortedPathsRules.push({from:o,to:m}):this.sortedPathsRules.push({from:o,to:[m]})}),this.sortedPathsRules.sort((o,m)=>m.from.length-o.from.length)}cloneAndMerge(o){return new D(this._env,E.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let m;for(let L=0,a=this.sortedPathsRules.length;L<a;L++)if(m=this.sortedPathsRules[L],O.Utilities.startsWith(o,m.from)){let s=[];for(let _=0,e=m.to.length;_<e;_++)s.push(m.to[_]+o.substr(m.from.length));return s}return[o]}_addUrlArgsToUrl(o){return O.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let m=0,L=o.length;m<L;m++)o[m]=this._addUrlArgsToUrl(o[m]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let m=o,L;if(!O.Utilities.endsWith(m,".js")&&!O.Utilities.isAbsolutePath(m)){L=this._applyPaths(m);for(let a=0,s=L.length;a<s;a++)this.isBuild()&&L[a]==="empty:"||(O.Utilities.isAbsolutePath(L[a])||(L[a]=this.options.baseUrl+L[a]),!O.Utilities.endsWith(L[a],".js")&&!O.Utilities.containsQueryString(L[a])&&(L[a]=L[a]+".js"))}else!O.Utilities.endsWith(m,".js")&&!O.Utilities.containsQueryString(m)&&(m=m+".js"),L=[m];return this._addUrlArgsIfNecessaryToUrls(L)}requireToUrl(o){let m=o;return O.Utilities.isAbsolutePath(m)||(m=this._applyPaths(m)[0],O.Utilities.isAbsolutePath(m)||(m=this.options.baseUrl+m)),this._addUrlArgsIfNecessaryToUrl(m)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}O.Configuration=D})(le||(le={}));var le;(function(O){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,_,e,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:v}=s.getConfig().getOptionsLiteral();v?this._scriptLoader=new E:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new E;let d={callback:e,errorback:h};if(this._callbackMap.hasOwnProperty(_)){this._callbackMap[_].push(d);return}this._callbackMap[_]=[d],this._scriptLoader.load(s,_,()=>this.triggerCallback(_),v=>this.triggerErrorback(_,v))}triggerCallback(s){let _=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<_.length;e++)_[e].callback()}triggerErrorback(s,_){let e=this._callbackMap[s];delete this._callbackMap[s];for(let h=0;h<e.length;h++)e[h].errorback(_)}}class E{attachListeners(s,_,e){let h=()=>{s.removeEventListener("load",d),s.removeEventListener("error",v)},d=b=>{h(),_()},v=b=>{h(),e(b)};s.addEventListener("load",d),s.addEventListener("error",v)}load(s,_,e,h){if(/^node\|/.test(_)){let d=s.getConfig().getOptionsLiteral(),v=m(s.getRecorder(),d.nodeRequire||O.global.nodeRequire),b=_.split("|"),p=null;try{p=v(b[1])}catch(N){h(N);return}s.enqueueDefineAnonymousModule([],()=>p),e()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,e,h);const{trustedTypesPolicy:v}=s.getConfig().getOptionsLiteral();v&&(_=v.createScriptURL(_)),d.setAttribute("src",_);const{cspNonce:b}=s.getConfig().getOptionsLiteral();b&&d.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(d)}}}function D(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,_,e,h){if(/^node\|/.test(_)){const d=s.getConfig().getOptionsLiteral(),v=m(s.getRecorder(),d.nodeRequire||O.global.nodeRequire),b=_.split("|");let p=null;try{p=v(b[1])}catch(N){h(N);return}s.enqueueDefineAnonymousModule([],function(){return p}),e()}else{const{trustedTypesPolicy:d}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(_).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${_}`,(d?self.eval(d.createScript("",b)):new Function(b)).call(self),e()}).then(void 0,h);return}try{d&&(_=d.createScriptURL(_)),importScripts(_),e()}catch(b){h(b)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,_){const{nodeCachedData:e}=_.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,d=s("module");function v(b){const p=b.constructor;let N=function(A){try{return b.require(A)}finally{}};return N.resolve=function(A,w){return p._resolveFilename(A,b,!1,w)},N.resolve.paths=function(A){return p._resolveLookupPaths(A,b)},N.main=process.mainModule,N.extensions=p._extensions,N.cache=p._cache,N}d.prototype._compile=function(b,p){const N=d.wrap(b.replace(/^#!.*/,"")),C=_.getRecorder(),A=h._getCachedDataPath(e,p),w={filename:p};let u;try{const M=h._fs.readFileSync(A);u=M.slice(0,16),w.cachedData=M.slice(16),C.record(60,A)}catch{C.record(61,A)}const r=new h._vm.Script(N,w),l=r.runInThisContext(w),c=h._path.dirname(p),f=v(this),g=[this.exports,f,this,p,c,process,Re,Buffer],S=l.apply(this.exports,g);return h._handleCachedData(r,N,A,!w.cachedData,_),h._verifyCachedData(r,N,A,u,_),S}}load(s,_,e,h){const d=s.getConfig().getOptionsLiteral(),v=m(s.getRecorder(),d.nodeRequire||O.global.nodeRequire),b=d.nodeInstrumenter||function(N){return N};this._init(v),this._initNodeRequire(v,s);let p=s.getRecorder();if(/^node\|/.test(_)){let N=_.split("|"),C=null;try{C=v(N[1])}catch(A){h(A);return}s.enqueueDefineAnonymousModule([],()=>C),e()}else{_=O.Utilities.fileUriToFilePath(this._env.isWindows,_);const N=this._path.normalize(_),C=this._getElectronRendererScriptPathOrUri(N),A=!!d.nodeCachedData,w=A?this._getCachedDataPath(d.nodeCachedData,_):void 0;this._readSourceAndCachedData(N,w,p,(u,r,l,c)=>{if(u){h(u);return}let f;r.charCodeAt(0)===o._BOM?f=o._PREFIX+r.substring(1)+o._SUFFIX:f=o._PREFIX+r+o._SUFFIX,f=b(f,N);const g={filename:C,cachedData:l},S=this._createAndEvalScript(s,f,g,e,h);this._handleCachedData(S,f,w,A&&!l,s),this._verifyCachedData(S,f,w,c,s)})}}_createAndEvalScript(s,_,e,h,d){const v=s.getRecorder();v.record(31,e.filename);const b=new this._vm.Script(_,e),p=b.runInThisContext(e),N=s.getGlobalAMDDefineFunc();let C=!1;const A=function(){return C=!0,N.apply(null,arguments)};return A.amd=N.amd,p.call(O.global,s.getGlobalAMDRequireFunc(),A,e.filename,this._path.dirname(e.filename)),v.record(32,e.filename),C?h():d(new Error(`Didn't receive define call in ${e.filename}!`)),b}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let _=s.match(/^([a-z])\:(.*)/i);return _?`file:///${(_[1].toUpperCase()+":"+_[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,_){const e=this._crypto.createHash("md5").update(_,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(_).replace(/\.js$/,"");return this._path.join(s.path,`${h}-${e}.code`)}_handleCachedData(s,_,e,h,d){s.cachedDataRejected?this._fs.unlink(e,v=>{d.getRecorder().record(62,e),this._createAndWriteCachedData(s,_,e,d),v&&d.getConfig().onError(v)}):h&&this._createAndWriteCachedData(s,_,e,d)}_createAndWriteCachedData(s,_,e,h){let d=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),v=-1,b=0,p;const N=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(_,"utf8").digest());const C=s.createCachedData();if(!(C.length===0||C.length===v||b>=5)){if(C.length<v){N();return}v=C.length,this._fs.writeFile(e,Buffer.concat([p,C]),A=>{A&&h.getConfig().onError(A),h.getRecorder().record(63,e),N()})}},d*Math.pow(4,b++))};N()}_readSourceAndCachedData(s,_,e,h){if(!_)this._fs.readFile(s,{encoding:"utf8"},h);else{let d,v,b,p=2;const N=C=>{C?h(C):--p===0&&h(void 0,d,v,b)};this._fs.readFile(s,{encoding:"utf8"},(C,A)=>{d=A,N(C)}),this._fs.readFile(_,(C,A)=>{!C&&A&&A.length>0?(b=A.slice(0,16),v=A.slice(16),e.record(60,_)):e.record(61,_),N()})}}_verifyCachedData(s,_,e,h,d){h&&(s.cachedDataRejected||setTimeout(()=>{const v=this._crypto.createHash("md5").update(_,"utf8").digest();h.equals(v)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,b=>{b&&d.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function m(a,s){if(s.__$__isRecorded)return s;const _=function(h){a.record(33,h);try{return s(h)}finally{a.record(34,h)}};return _.__$__isRecorded=!0,_}O.ensureRecordedNodeRequire=m;function L(a){return new n(a)}O.createScriptLoader=L})(le||(le={}));var le;(function(O){class n{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,_;for(_=/\/\.\//;_.test(s);)s=s.replace(_,"/");for(s=s.replace(/^\.\//g,""),_=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;_.test(s);)s=s.replace(_,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),O.ModuleIdResolver=n;class E{constructor(a,s,_,e,h,d){this.id=a,this.strId=s,this.dependencies=_,this._callback=e,this._errorback=h,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(O.global,s),producedError:null}}catch(_){return{returnedValue:null,producedError:_}}}static _invokeFactory(a,s,_,e){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(_,e):{returnedValue:_.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,_,e){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let d=E._invokeFactory(s,this.strId,this._callback,_);h=d.producedError,a.record(22,this.strId),!h&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(h){let d=O.ensureError(h);d.phase="factory",d.moduleId=this.strId,d.neededBy=e(this.id),this.error=d,s.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=E;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class o{constructor(a,s,_){this.id=a,this.pluginId=s,this.pluginParam=_}}O.PluginDependency=o;class m{constructor(a,s,_,e,h=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=h,this._defineFunc=_,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let _=d=>d.replace(/\\/g,"/"),e=_(a),h=s.split(/\n/);for(let d=0;d<h.length;d++){let v=h[d].match(/(.*):(\d+):(\d+)\)?$/);if(v){let b=v[1],p=v[2],N=v[3],C=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(C),b=_(b),b===e){let A={line:parseInt(p,10),col:parseInt(N,10)};return A.line===1&&(A.col-=53),A}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let _=0,e=this._modules2.length;_<e;_++){let h=this._modules2[_];if(!h)continue;let d=this._buildInfoPath[h.id]||null,v=this._buildInfoDefineStack[h.id]||null,b=this._buildInfoDependencies[h.id];a[s++]={id:h.strId,path:d,defineLocation:d&&v?m._findRelevantLocationInStack(d,v):null,dependencies:b,shim:null,exports:h.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let _=null;this._config.isBuild()&&(_=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:_,dependencies:a,callback:s}}defineModule(a,s,_,e,h,d=new n(a)){let v=this._moduleIdProvider.getModuleId(a);if(this._modules2[v]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let b=new E(v,a,this._normalizeDependencies(s,d),_,e,d);this._modules2[v]=b,this._config.isBuild()&&(this._buildInfoDefineStack[v]=h,this._buildInfoDependencies[v]=(b.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(b)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let _=a.indexOf("!");if(_>=0){let e=s.resolveModule(a.substr(0,_)),h=s.resolveModule(a.substr(_+1)),d=this._moduleIdProvider.getModuleId(e+"!"+h),v=this._moduleIdProvider.getModuleId(e);return new o(d,v,h)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let _=[],e=0;for(let h=0,d=a.length;h<d;h++)_[e++]=this._normalizeDependency(a[h],s);return _}_relativeRequire(a,s,_,e){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(O.Utilities.generateAnonymousModule(),s,_,e,null,a)}synchronousRequire(a,s=new n(a)){let _=this._normalizeDependency(a,s),e=this._modules2[_.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(a,s){let _=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!_&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let _=this._moduleIdProvider.getStrModuleId(a),e=(this._inverseDependencies2[a]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const h=O.ensureError(s);return h.phase="loading",h.moduleId=_,h.neededBy=e,h}_onLoadError(a,s){const _=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new E(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let e=[];for(let v=0,b=this._moduleIdProvider.getMaxModuleId();v<b;v++)e[v]=!1;let h=!1,d=[];for(d.push(a),e[a]=!0;d.length>0;){let v=d.shift(),b=this._modules2[v];b&&(h=b.onDependencyError(_)||h);let p=this._inverseDependencies2[v];if(p)for(let N=0,C=p.length;N<C;N++){let A=p[N];e[A]||(d.push(A),e[A]=!0)}}h||this._config.onError(_)}_hasDependencyPath(a,s){let _=this._modules2[a];if(!_)return!1;let e=[];for(let d=0,v=this._moduleIdProvider.getMaxModuleId();d<v;d++)e[d]=!1;let h=[];for(h.push(_),e[a]=!0;h.length>0;){let v=h.shift().dependencies;if(v)for(let b=0,p=v.length;b<p;b++){let N=v[b];if(N.id===s)return!0;let C=this._modules2[N.id];C&&!e[N.id]&&(e[N.id]=!0,h.push(C))}}return!1}_findCyclePath(a,s,_){if(a===s||_===50)return[a];let e=this._modules2[a];if(!e)return null;let h=e.dependencies;if(h)for(let d=0,v=h.length;d<v;d++){let b=this._findCyclePath(h[d].id,s,_+1);if(b!==null)return b.push(a),b}return null}_createRequire(a){let s=(_,e,h)=>this._relativeRequire(a,_,e,h);return s.toUrl=_=>this._config.requireToUrl(a.resolveModule(_)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(_,e=!1)=>{this.configure(_,e)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),_=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&_.push("node|"+s);let h=-1,d=v=>{if(h++,h>=_.length)this._onLoadError(a,v);else{let b=_[h],p=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[a]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}p.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=b),p.record(11,b),this._onLoad(a)},N=>{p.record(12,b),d(N)})}};d(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let _=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};_.error=e=>{this._config.onError(this._createLoadError(s.id,e))},a.load(s.pluginParam,this._createRequire(n.ROOT),_,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let _=0,e=s.length;_<e;_++){let h=s[_];if(h===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(h===i.MODULE){a.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let d=this._modules2[h.id];if(d&&d.isComplete()){if(d.error){a.onDependencyError(d.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let v=this._findCyclePath(h.id,a.id,0)||[];v.reverse(),v.push(h.id),console.warn(v.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(a.id),h instanceof o){let v=this._modules2[h.pluginId];if(v&&v.isComplete()){this._loadPluginDependency(v.exports,h);continue}let b=this._inversePluginDependencies2.get(h.pluginId);b||(b=[],this._inversePluginDependencies2.set(h.pluginId,b)),b.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let _=a.dependencies,e=[];if(_)for(let b=0,p=_.length;b<p;b++){let N=_[b];if(N===i.EXPORTS){e[b]=a.exports;continue}if(N===i.MODULE){e[b]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===i.REQUIRE){e[b]=this._createRequire(a.moduleIdResolver);continue}let C=this._modules2[N.id];if(C){e[b]=C.exports;continue}e[b]=null}const h=b=>(this._inverseDependencies2[b]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));a.complete(s,this._config,e,h);let d=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,d)for(let b=0,p=d.length;b<p;b++){let N=d[b],C=this._modules2[N];C.unresolvedDependenciesCount--,C.unresolvedDependenciesCount===0&&this._onModuleComplete(C)}let v=this._inversePluginDependencies2.get(a.id);if(v){this._inversePluginDependencies2.delete(a.id);for(let b=0,p=v.length;b<p;b++)this._loadPluginDependency(a.exports,v[b])}}}O.ModuleManager=m})(le||(le={}));var J,le;(function(O){const n=new O.Environment;let E=null;const D=function(L,a,s){typeof L!="string"&&(s=a,a=L,L=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),L?E.defineModule(L,a,s,null,null):E.enqueueDefineAnonymousModule(a,s)};D.amd={jQuery:!0};const i=function(L,a=!1){E.configure(L,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return E.getConfig().getOptionsLiteral()},o.reset=function(){E=E.reset()},o.getBuildInfo=function(){return E.getBuildInfo()},o.getStats=function(){return E.getLoaderEvents()},o.define=D;function m(){if(typeof O.global.require<"u"||typeof require<"u"){const L=O.global.require||require;if(typeof L=="function"&&typeof L.resolve=="function"){const a=O.ensureRecordedNodeRequire(E.getRecorder(),L);O.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=o:(n.isElectronRenderer||(O.global.define=D),O.global.require=o)}O.init=m,(typeof O.global.define!="function"||!O.global.define.amd)&&(E=new O.ModuleManager(n,O.createScriptLoader(n),D,o,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&o.config(O.global.require),J=function(){return D.apply(null,arguments)},J.amd=D.amd,typeof doNotInitLoader>"u"&&m())})(le||(le={}));var de=this&&this.__awaiter||function(O,n,E,D){function i(o){return o instanceof E?o:new E(function(m){m(o)})}return new(E||(E=Promise))(function(o,m){function L(_){try{s(D.next(_))}catch(e){m(e)}}function a(_){try{s(D.throw(_))}catch(e){m(e)}}function s(_){_.done?o(_.value):i(_.value).then(L,a)}s((D=D.apply(O,n||[])).next())})};J(Z[25],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(v,b){let p;return b.length===0?p=v:p=v.replace(/\{(\d+)\}/g,(N,C)=>{const A=C[0],w=b[A];let u=N;return typeof w=="string"?u=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(u=String(w)),u}),E&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function o(v,b){let p=v[b];return p||(p=v["*"],p)?p:null}function m(v){return v.charAt(v.length-1)==="/"?v:v+"/"}function L(v,b,p){return de(this,void 0,void 0,function*(){const N=m(v)+m(b)+"vscode/"+m(p),C=yield fetch(N);if(C.ok)return yield C.json();throw new Error(`${C.status} - ${C.statusText}`)})}function a(v){return function(b,p){const N=Array.prototype.slice.call(arguments,2);return i(v[b],N)}}function s(v,b,...p){return i(b,p)}n.localize=s;function _(v){}n.getConfiguredDefaultLocale=_;function e(v){E=v}n.setPseudoTranslation=e;function h(v,b){var p;return{localize:a(b[v]),getConfiguredDefaultLocale:(p=b.getConfiguredDefaultLocale)!==null&&p!==void 0?p:N=>{}}}n.create=h;function d(v,b,p,N){var C;const A=(C=N["vs/nls"])!==null&&C!==void 0?C:{};if(!v||v.length===0)return p({localize:s,getConfiguredDefaultLocale:()=>{var c;return(c=A.availableLanguages)===null||c===void 0?void 0:c["*"]}});const w=A.availableLanguages?o(A.availableLanguages,v):null,u=w===null||w===D;let r=".nls";u||(r=r+"."+w);const l=c=>{Array.isArray(c)?c.localize=a(c):c.localize=a(c[v]),c.getConfiguredDefaultLocale=()=>{var f;return(f=A.availableLanguages)===null||f===void 0?void 0:f["*"]},p(c)};typeof A.loadBundle=="function"?A.loadBundle(v,w,(c,f)=>{c?b([v+".nls"],l):l(f)}):A.translationServiceUrl&&!u?de(this,void 0,void 0,function*(){var c;try{const f=yield L(A.translationServiceUrl,w,v);return l(f)}catch(f){if(!w.includes("-"))return console.error(f),b([v+".nls"],l);try{const g=w.split("-")[0],S=yield L(A.translationServiceUrl,g,v);return(c=A.availableLanguages)!==null&&c!==void 0||(A.availableLanguages={}),A.availableLanguages["*"]=g,l(S)}catch(g){return console.error(g),b([v+".nls"],l)}}}):b([v+r],l,c=>{if(r===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${w}. Falling back to the default language:`,c),b([v+".nls"],l)})}n.load=d}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function E(_,e){var h;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(_,e)}catch(d){console.warn(d);return}try{return(h=self.trustedTypes)===null||h===void 0?void 0:h.createPolicy(_,e)}catch(d){console.warn(d);return}}const D=E("amdLoader",{createScriptURL:_=>_,createScript:(_,...e)=>{const h=e.slice(0,-1).join(","),d=e.pop().toString();return`(function anonymous(${h}) { ${d}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((_,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return _();const h=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(h).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${h}`,(D?globalThis.eval(D.createScript("",v)):new Function(v)).call(globalThis),_()}).then(void 0,e);return}D?importScripts(D.createScriptURL(h)):importScripts(h),_()})}function m(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function L(_){o().then(()=>{m(),require([_],function(e){setTimeout(function(){const h=e.create((d,v)=>{globalThis.postMessage(d,v)},null);for(globalThis.onmessage=d=>h.onmessage(d.data,d.ports);s.length>0;){const d=s.shift();h.onmessage(d.data,d.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&m();let a=!0;const s=[];globalThis.onmessage=_=>{if(!a){s.push(_);return}a=!1,L(_.data)}}(),J(Z[26],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(I,T=0){return I[I.length-(1+T)]}n.tail=E;function D(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=D;function i(I,T,q=(z,t)=>z===t){if(I===T)return!0;if(!I||!T||I.length!==T.length)return!1;for(let z=0,t=I.length;z<t;z++)if(!q(I[z],T[z]))return!1;return!0}n.equals=i;function o(I,T){const q=I.length-1;T<q&&(I[T]=I[q]),I.pop()}n.removeFastWithoutKeepingOrder=o;function m(I,T,q){return L(I.length,z=>q(I[z],T))}n.binarySearch=m;function L(I,T){let q=0,z=I-1;for(;q<=z;){const t=(q+z)/2|0,se=T(t);if(se<0)q=t+1;else if(se>0)z=t-1;else return t}return-(q+1)}n.binarySearch2=L;function a(I,T){let q=0,z=I.length;if(z===0)return 0;for(;q<z;){const t=Math.floor((q+z)/2);T(I[t])?z=t:q=t+1}return q}n.findFirstInSorted=a;function s(I,T,q){if(I=I|0,I>=T.length)throw new TypeError("invalid index");const z=T[Math.floor(T.length*Math.random())],t=[],se=[],ne=[];for(const ce of T){const ge=q(ce,z);ge<0?t.push(ce):ge>0?se.push(ce):ne.push(ce)}return I<t.length?s(I,t,q):I<t.length+ne.length?ne[0]:s(I-(t.length+ne.length),se,q)}n.quickSelect=s;function _(I,T){const q=[];let z;for(const t of I.slice(0).sort(T))!z||T(z[0],t)!==0?(z=[t],q.push(z)):z.push(t);return q}n.groupBy=_;function e(I){return I.filter(T=>!!T)}n.coalesce=e;function h(I){let T=0;for(let q=0;q<I.length;q++)I[q]&&(I[T]=I[q],T+=1);I.length=T}n.coalesceInPlace=h;function d(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=d;function v(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=v;function b(I,T=q=>q){const q=new Set;return I.filter(z=>{const t=T(z);return q.has(t)?!1:(q.add(t),!0)})}n.distinct=b;function p(I,T){const q=N(I,T);if(q!==-1)return I[q]}n.findLast=p;function N(I,T){for(let q=I.length-1;q>=0;q--){const z=I[q];if(T(z))return q}return-1}n.lastIndex=N;function C(I,T){return I.length>0?I[0]:T}n.firstOrDefault=C;function A(I,T){let q=typeof T=="number"?I:0;typeof T=="number"?q=I:(q=0,T=I);const z=[];if(q<=T)for(let t=q;t<T;t++)z.push(t);else for(let t=q;t>T;t--)z.push(t);return z}n.range=A;function w(I,T,q){const z=I.slice(0,T),t=I.slice(T);return z.concat(q,t)}n.arrayInsert=w;function u(I,T){const q=I.indexOf(T);q>-1&&(I.splice(q,1),I.unshift(T))}n.pushToStart=u;function r(I,T){const q=I.indexOf(T);q>-1&&(I.splice(q,1),I.push(T))}n.pushToEnd=r;function l(I,T){for(const q of T)I.push(q)}n.pushMany=l;function c(I){return Array.isArray(I)?I:[I]}n.asArray=c;function f(I,T){for(const q of I){const z=T(q);if(z!==void 0)return z}}n.mapFind=f;function g(I,T,q){const z=M(I,T),t=I.length,se=q.length;I.length=t+se;for(let ne=t-1;ne>=z;ne--)I[ne+se]=I[ne];for(let ne=0;ne<se;ne++)I[ne+z]=q[ne]}n.insertInto=g;function S(I,T,q,z){const t=M(I,T),se=I.splice(t,q);return g(I,t,z),se}n.splice=S;function M(I,T){return T<0?Math.max(T+I.length,0):Math.min(T,I.length)}var y;(function(I){function T(t){return t<0}I.isLessThan=T;function q(t){return t>0}I.isGreaterThan=q;function z(t){return t===0}I.isNeitherLessOrGreaterThan=z,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(y||(n.CompareResult=y={}));function R(I,T){return(q,z)=>T(I(q),I(z))}n.compareBy=R;const F=(I,T)=>I-T;n.numberComparator=F;function U(I,T){if(I.length===0)return;let q=I[0];for(let z=1;z<I.length;z++){const t=I[z];T(t,q)>0&&(q=t)}return q}n.findMaxBy=U;function P(I,T){if(I.length===0)return;let q=I[0];for(let z=1;z<I.length;z++){const t=I[z];T(t,q)>=0&&(q=t)}return q}n.findLastMaxBy=P;function x(I,T){return U(I,(q,z)=>-T(q,z))}n.findMinBy=x;class W{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let q=this.firstIdx;for(;q<this.items.length&&T(this.items[q]);)q++;const z=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,z}takeFromEndWhile(T){let q=this.lastIdx;for(;q>=0&&T(this.items[q]);)q--;const z=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const q=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,q}}n.ArrayQueue=W;class ${constructor(T){this.iterate=T}toArray(){const T=[];return this.iterate(q=>(T.push(q),!0)),T}filter(T){return new $(q=>this.iterate(z=>T(z)?q(z):!0))}map(T){return new $(q=>this.iterate(z=>q(T(z))))}findLast(T){let q;return this.iterate(z=>(T(z)&&(q=z),!0)),q}findLastMaxBy(T){let q,z=!0;return this.iterate(t=>((z||y.isGreaterThan(T(t,q)))&&(z=!1,q=t),!0)),q}}n.CallbackIterable=$,$.empty=new $(I=>{})}),J(Z[27],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(o){this.fn=o,this.lastCache=void 0,this.lastArgKey=void 0}get(o){const m=JSON.stringify(o);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(o)),this.lastCache}}n.LRUCachedFunction=E;class D{get cachedValues(){return this._map}constructor(o){this.fn=o,this._map=new Map}get(o){if(this._map.has(o))return this._map.get(o);const m=this.fn(o);return this._map.set(o,m),m}}n.CachedFunction=D}),J(Z[28],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function E(L,a){const s=Math.pow(10,a);return Math.round(L*s)/s}class D{constructor(a,s,_,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}n.RGBA=D;class i{constructor(a,s,_,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.l=E(Math.max(Math.min(1,_),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,_=a.g/255,e=a.b/255,h=a.a,d=Math.max(s,_,e),v=Math.min(s,_,e);let b=0,p=0;const N=(v+d)/2,C=d-v;if(C>0){switch(p=Math.min(N<=.5?C/(2*N):C/(2-2*N),1),d){case s:b=(_-e)/C+(_<e?6:0);break;case _:b=(e-s)/C+2;break;case e:b=(s-_)/C+4;break}b*=60,b=Math.round(b)}return new i(b,p,N,h)}static _hue2rgb(a,s,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?a+(s-a)*6*_:_<1/2?s:_<2/3?a+(s-a)*(2/3-_)*6:a}static toRGBA(a){const s=a.h/360,{s:_,l:e,a:h}=a;let d,v,b;if(_===0)d=v=b=e;else{const p=e<.5?e*(1+_):e+_-e*_,N=2*e-p;d=i._hue2rgb(N,p,s+1/3),v=i._hue2rgb(N,p,s),b=i._hue2rgb(N,p,s-1/3)}return new D(Math.round(d*255),Math.round(v*255),Math.round(b*255),h)}}n.HSLA=i;class o{constructor(a,s,_,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.v=E(Math.max(Math.min(1,_),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,_=a.g/255,e=a.b/255,h=Math.max(s,_,e),d=Math.min(s,_,e),v=h-d,b=h===0?0:v/h;let p;return v===0?p=0:h===s?p=((_-e)/v%6+6)%6:h===_?p=(e-s)/v+2:p=(s-_)/v+4,new o(Math.round(p*60),b,h,a.a)}static toRGBA(a){const{h:s,s:_,v:e,a:h}=a,d=e*_,v=d*(1-Math.abs(s/60%2-1)),b=e-d;let[p,N,C]=[0,0,0];return s<60?(p=d,N=v):s<120?(p=v,N=d):s<180?(N=d,C=v):s<240?(N=v,C=d):s<300?(p=v,C=d):s<=360&&(p=d,C=v),p=Math.round((p+b)*255),N=Math.round((N+b)*255),C=Math.round((C+b)*255),new D(p,N,C,h)}}n.HSVA=o;class m{static fromHex(a){return m.Format.CSS.parseHex(a)||m.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof D)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof o)this._hsva=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&D.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=m._relativeLuminanceForComponent(this.rgba.r),s=m._relativeLuminanceForComponent(this.rgba.g),_=m._relativeLuminanceForComponent(this.rgba.b),e=.2126*a+.7152*s+.0722*_;return E(e,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),_=a.getRelativeLuminance();return s>_}isDarkerThan(a){const s=this.getRelativeLuminance(),_=a.getRelativeLuminance();return s<_}lighten(a){return new m(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new m(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:_,b:e,a:h}=this.rgba;return new m(new D(s,_,e,h*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:_,b:e,a:h}=this.rgba;return new m(new D(a.rgba.r-h*(a.rgba.r-s),a.rgba.g-h*(a.rgba.g-_),a.rgba.b-h*(a.rgba.b-e),1))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,_){if(a.isLighterThan(s))return a;_=_||.5;const e=a.getRelativeLuminance(),h=s.getRelativeLuminance();return _=_*(h-e)/h,a.lighten(_)}static getDarkerColor(a,s,_){if(a.isDarkerThan(s))return a;_=_||.5;const e=a.getRelativeLuminance(),h=s.getRelativeLuminance();return _=_*(e-h)/e,a.darken(_)}}n.Color=m,m.white=new m(new D(255,255,255,1)),m.black=new m(new D(0,0,0,1)),m.red=new m(new D(255,0,0,1)),m.blue=new m(new D(0,0,255,1)),m.green=new m(new D(0,255,0,1)),m.cyan=new m(new D(0,255,255,1)),m.lightgrey=new m(new D(211,211,211,1)),m.transparent=new m(new D(0,0,0,0)),function(L){let a;(function(s){let _;(function(e){function h(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:L.Format.CSS.formatRGBA(r)}e.formatRGB=h;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=d;function v(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:L.Format.CSS.formatHSLA(r)}e.formatHSL=v;function b(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=b;function p(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function N(r){return`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}`}e.formatHex=N;function C(r,l=!1){return l&&r.rgba.a===1?L.Format.CSS.formatHex(r):`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}${p(Math.round(r.rgba.a*255))}`}e.formatHexA=C;function A(r){return r.isOpaque()?L.Format.CSS.formatHex(r):L.Format.CSS.formatRGBA(r)}e.format=A;function w(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const c=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),f=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),g=16*u(r.charCodeAt(5))+u(r.charCodeAt(6));return new L(new D(c,f,g,1))}if(l===9){const c=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),f=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),g=16*u(r.charCodeAt(5))+u(r.charCodeAt(6)),S=16*u(r.charCodeAt(7))+u(r.charCodeAt(8));return new L(new D(c,f,g,S/255))}if(l===4){const c=u(r.charCodeAt(1)),f=u(r.charCodeAt(2)),g=u(r.charCodeAt(3));return new L(new D(16*c+c,16*f+f,16*g+g))}if(l===5){const c=u(r.charCodeAt(1)),f=u(r.charCodeAt(2)),g=u(r.charCodeAt(3)),S=u(r.charCodeAt(4));return new L(new D(16*c+c,16*f+f,16*g+g,(16*S+S)/255))}return null}e.parseHex=w;function u(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(_=s.CSS||(s.CSS={}))})(a=L.Format||(L.Format={}))}(m||(n.Color=m={}))}),J(Z[29],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,o,m,L){this.originalStart=i,this.originalLength=o,this.modifiedStart=m,this.modifiedLength=L}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),J(Z[4],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(p){setTimeout(()=>{throw p.stack?d.isErrorNoTelemetry(p)?new d(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}emit(p){this.listeners.forEach(N=>{N(p)})}onUnexpectedError(p){this.unexpectedErrorHandler(p),this.emit(p)}onUnexpectedExternalError(p){this.unexpectedErrorHandler(p)}}n.ErrorHandler=E,n.errorHandler=new E;function D(b){L(b)||n.errorHandler.onUnexpectedError(b)}n.onUnexpectedError=D;function i(b){L(b)||n.errorHandler.onUnexpectedExternalError(b)}n.onUnexpectedExternalError=i;function o(b){if(b instanceof Error){const{name:p,message:N}=b,C=b.stacktrace||b.stack;return{$isError:!0,name:p,message:N,stack:C,noTelemetry:d.isErrorNoTelemetry(b)}}return b}n.transformErrorForSerialization=o;const m="Canceled";function L(b){return b instanceof a?!0:b instanceof Error&&b.name===m&&b.message===m}n.isCancellationError=L;class a extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=a;function s(){const b=new Error(m);return b.name=b.message,b}n.canceled=s;function _(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}n.illegalArgument=_;function e(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}n.illegalState=e;class h extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}n.NotSupportedError=h;class d extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof d)return p;const N=new d;return N.message=p.message,N.stack=p.stack,N}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}n.ErrorNoTelemetry=d;class v extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}n.BugIndicatingError=v}),J(Z[9],K([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(L,a){if(!L)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}n.ok=D;function i(L,a="Unreachable"){throw new Error(a)}n.assertNever=i;function o(L){if(!L()){debugger;L(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=o;function m(L,a){let s=0;for(;s<L.length-1;){const _=L[s],e=L[s+1];if(!a(_,e))return!1;s++}return!0}n.checkAdjacentItems=m}),J(Z[15],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(D){const i=this;let o=!1,m;return function(){return o||(o=!0,m=D.apply(i,arguments)),m}}n.once=E}),J(Z[16],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(D){function i(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}D.is=i;const o=Object.freeze([]);function m(){return o}D.empty=m;function*L(w){yield w}D.single=L;function a(w){return i(w)?w:L(w)}D.wrap=a;function s(w){return w||o}D.from=s;function _(w){return!w||w[Symbol.iterator]().next().done===!0}D.isEmpty=_;function e(w){return w[Symbol.iterator]().next().value}D.first=e;function h(w,u){for(const r of w)if(u(r))return!0;return!1}D.some=h;function d(w,u){for(const r of w)if(u(r))return r}D.find=d;function*v(w,u){for(const r of w)u(r)&&(yield r)}D.filter=v;function*b(w,u){let r=0;for(const l of w)yield u(l,r++)}D.map=b;function*p(...w){for(const u of w)for(const r of u)yield r}D.concat=p;function N(w,u,r){let l=r;for(const c of w)l=u(l,c);return l}D.reduce=N;function*C(w,u,r=w.length){for(u<0&&(u+=w.length),r<0?r+=w.length:r>w.length&&(r=w.length);u<r;u++)yield w[u]}D.slice=C;function A(w,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,w];const l=w[Symbol.iterator]();for(let c=0;c<u;c++){const f=l.next();if(f.done)return[r,D.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return l}}]}D.consume=A})(E||(n.Iterable=E={}))}),J(Z[30],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,d){this._keyCodeToStr[h]=d,this._strToKeyCode[d.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new E,i=new E,o=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],L=Object.create(null),a=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],d=[],v=[];for(const b of h){const[p,N,C,A,w,u,r,l,c]=b;if(v[N]||(v[N]=!0,m[N]=C,L[C]=N,a[C.toLowerCase()]=N,p&&(n.IMMUTABLE_CODE_TO_KEY_CODE[N]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[A]=N))),!d[A]){if(d[A]=!0,!w)throw new Error(`String representation missing for key code ${A} around scan code ${C}`);D.define(A,w),i.define(A,l||w),o.define(A,c||l||w)}u&&(n.EVENT_KEY_CODE_MAP[u]=A),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=A)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function h(C){return D.keyCodeToStr(C)}e.toString=h;function d(C){return D.strToKeyCode(C)}e.fromString=d;function v(C){return i.keyCodeToStr(C)}e.toUserSettingsUS=v;function b(C){return o.keyCodeToStr(C)}e.toUserSettingsGeneral=b;function p(C){return i.strToKeyCode(C)||o.strToKeyCode(C)}e.fromUserSettings=p;function N(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(C)}e.toElectronAccelerator=N})(s||(n.KeyCodeUtils=s={}));function _(e,h){const d=(h&65535)<<16>>>0;return(e|d)>>>0}n.KeyChord=_}),J(Z[31],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),J(Z[10],K([0,1,15,16]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let o=null;function m(l){o=l}if(n.setDisposableTracker=m,i){const l="__is_disposable_tracked__";m(new class{trackDisposable(c){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[l]||console.log(f)},3e3)}setParent(c,f){if(c&&c!==N.None)try{c[l]=!0}catch{}}markAsDisposed(c){if(c&&c!==N.None)try{c[l]=!0}catch{}}markAsSingleton(c){}})}function L(l){return o?.trackDisposable(l),l}function a(l){o?.markAsDisposed(l)}function s(l,c){o?.setParent(l,c)}function _(l,c){if(o)for(const f of l)o.setParent(f,c)}function e(l){return o?.markAsSingleton(l),l}n.markAsSingleton=e;function h(l){return typeof l.dispose=="function"&&l.dispose.length===0}n.isDisposable=h;function d(l){if(D.Iterable.is(l)){const c=[];for(const f of l)if(f)try{f.dispose()}catch(g){c.push(g)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}n.dispose=d;function v(...l){const c=b(()=>d(l));return _(l,c),c}n.combinedDisposable=v;function b(l){const c=L({dispose:(0,E.once)(()=>{a(c),l()})});return c}n.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,L(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return s(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}n.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new p,L(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}n.Disposable=N,N.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,L(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var f;this._isDisposed||c===this._value||((f=this._value)===null||f===void 0||f.dispose(),c&&s(c,this),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,a(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}n.MutableDisposable=C;class A{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=A;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(c){let f=c;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,a(this))},this}}n.SafeDisposable=w;class u{constructor(c){this.object=c}dispose(){}}n.ImmortalReference=u;class r{constructor(){this._store=new Map,this._isDisposed=!1,L(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}get(c){return this._store.get(c)}set(c,f,g=!1){var S;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||(S=this._store.get(c))===null||S===void 0||S.dispose(),this._store.set(c,f)}deleteAndDispose(c){var f;(f=this._store.get(c))===null||f===void 0||f.dispose(),this._store.delete(c)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=r}),J(Z[17],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(o){this.element=o,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class D{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let o=this._first;for(;o!==E.Undefined;){const m=o.next;o.prev=E.Undefined,o.next=E.Undefined,o=m}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,m){const L=new E(o);if(this._first===E.Undefined)this._first=L,this._last=L;else if(m){const s=this._last;this._last=L,L.prev=s,s.next=L}else{const s=this._first;this._first=L,L.next=s,s.prev=L}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(L))}}shift(){if(this._first!==E.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==E.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==E.Undefined&&o.next!==E.Undefined){const m=o.prev;m.next=o.next,o.next.prev=m}else o.prev===E.Undefined&&o.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):o.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):o.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==E.Undefined;)yield o.element,o=o.next}}n.LinkedList=D}),J(Z[18],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(o){return new D(o)}constructor(o){this._now=E&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=D}),J(Z[7],K([0,1,4,15,10,17,18]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.EventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const L=!1,a=!1;var s;(function(f){f.None=()=>i.Disposable.None;function g(j){if(a){const{onDidAddListener:H}=j,Q=d.create();let G=0;j.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),H?.()}}}function S(j,H){return $(j,()=>{},0,void 0,!0,void 0,H)}f.defer=S;function M(j){return(H,Q=null,G)=>{let X=!1,te;return te=j(ie=>{if(!X)return te?te.dispose():X=!0,H.call(Q,ie)},null,G),X&&te.dispose(),te}}f.once=M;function y(j,H,Q){return W((G,X=null,te)=>j(ie=>G.call(X,H(ie)),null,te),Q)}f.map=y;function R(j,H,Q){return W((G,X=null,te)=>j(ie=>{H(ie),G.call(X,ie)},null,te),Q)}f.forEach=R;function F(j,H,Q){return W((G,X=null,te)=>j(ie=>H(ie)&&G.call(X,ie),null,te),Q)}f.filter=F;function U(j){return j}f.signal=U;function P(...j){return(H,Q=null,G)=>(0,i.combinedDisposable)(...j.map(X=>X(te=>H.call(Q,te),null,G)))}f.any=P;function x(j,H,Q,G){let X=Q;return y(j,te=>(X=H(X,te),X),G)}f.reduce=x;function W(j,H){let Q;const G={onWillAddFirstListener(){Q=j(X.fire,X)},onDidRemoveLastListener(){Q?.dispose()}};H||g(G);const X=new b(G);return H?.add(X),X.event}function $(j,H,Q=100,G=!1,X=!1,te,ie){let he,Se,ue,pe=0,k;const B={leakWarningThreshold:te,onWillAddFirstListener(){he=j(Y=>{pe++,Se=H(Se,Y),G&&!ue&&(V.fire(Se),Se=void 0),k=()=>{const ee=Se;Se=void 0,ue=void 0,(!G||pe>1)&&V.fire(ee),pe=0},typeof Q=="number"?(clearTimeout(ue),ue=setTimeout(k,Q)):ue===void 0&&(ue=0,queueMicrotask(k))})},onWillRemoveListener(){X&&pe>0&&k?.()},onDidRemoveLastListener(){k=void 0,he.dispose()}};ie||g(B);const V=new b(B);return ie?.add(V),V.event}f.debounce=$;function I(j,H=0,Q){return f.debounce(j,(G,X)=>G?(G.push(X),G):[X],H,void 0,!0,void 0,Q)}f.accumulate=I;function T(j,H=(G,X)=>G===X,Q){let G=!0,X;return F(j,te=>{const ie=G||!H(te,X);return G=!1,X=te,ie},Q)}f.latch=T;function q(j,H,Q){return[f.filter(j,H,Q),f.filter(j,G=>!H(G),Q)]}f.split=q;function z(j,H=!1,Q=[]){let G=Q.slice(),X=j(he=>{G?G.push(he):ie.fire(he)});const te=()=>{G?.forEach(he=>ie.fire(he)),G=null},ie=new b({onWillAddFirstListener(){X||(X=j(he=>ie.fire(he)))},onDidAddFirstListener(){G&&(H?setTimeout(te):te())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return ie.event}f.buffer=z;class t{constructor(H){this.event=H,this.disposables=new i.DisposableStore}map(H){return new t(y(this.event,H,this.disposables))}forEach(H){return new t(R(this.event,H,this.disposables))}filter(H){return new t(F(this.event,H,this.disposables))}reduce(H,Q){return new t(x(this.event,H,Q,this.disposables))}latch(){return new t(T(this.event,void 0,this.disposables))}debounce(H,Q=100,G=!1,X=!1,te){return new t($(this.event,H,Q,G,X,te,this.disposables))}on(H,Q,G){return this.event(H,Q,G)}once(H,Q,G){return M(this.event)(H,Q,G)}dispose(){this.disposables.dispose()}}function se(j){return new t(j)}f.chain=se;function ne(j,H,Q=G=>G){const G=(...he)=>ie.fire(Q(...he)),X=()=>j.on(H,G),te=()=>j.removeListener(H,G),ie=new b({onWillAddFirstListener:X,onDidRemoveLastListener:te});return ie.event}f.fromNodeEventEmitter=ne;function ce(j,H,Q=G=>G){const G=(...he)=>ie.fire(Q(...he)),X=()=>j.addEventListener(H,G),te=()=>j.removeEventListener(H,G),ie=new b({onWillAddFirstListener:X,onDidRemoveLastListener:te});return ie.event}f.fromDOMEventEmitter=ce;function ge(j){return new Promise(H=>M(j)(H))}f.toPromise=ge;function me(j,H){return H(void 0),j(Q=>H(Q))}f.runAndSubscribe=me;function _e(j,H){let Q=null;function G(te){Q?.dispose(),Q=new i.DisposableStore,H(te,Q)}G(void 0);const X=j(te=>G(te));return(0,i.toDisposable)(()=>{X.dispose(),Q?.dispose()})}f.runAndSubscribeWithStore=_e;class ve{constructor(H,Q){this._observable=H,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};Q||g(G),this.emitter=new b(G),Q&&Q.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,Q){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Le(j,H){return new ve(j,H).emitter.event}f.fromObservable=Le;function re(j){return H=>{let Q=0,G=!1;const X={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(j.reportChanges(),G&&(G=!1,H()))},handlePossibleChange(){},handleChange(){G=!0}};return j.addObserver(X),{dispose(){j.removeObserver(X)}}}}f.fromObservableLight=re})(s||(n.Event=s={}));class _{constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${_._idPool++}`,_.all.add(this)}start(g){this._stopWatch=new m.StopWatch,this.listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=_,_.all=new Set,_._idPool=0;let e=-1;class h{constructor(g,S=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=S,this._warnCountdown=0}dispose(){var g;(g=this._stacks)===null||g===void 0||g.clear()}check(g,S){const M=this.threshold;if(M<=0||S<M)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(g.value)||0;if(this._stacks.set(g.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let R,F=0;for(const[U,P]of this._stacks)(!R||F<P)&&(R=U,F=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${F}):`),console.warn(R)}return()=>{const R=this._stacks.get(g.value)||0;this._stacks.set(g.value,R-1)}}}class d{static create(){var g;return new d((g=new Error().stack)!==null&&g!==void 0?g:"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(g,S,M){this.callback=g,this.callbackThis=S,this.stack=M,this.subscription=new i.SafeDisposable}invoke(g){this.callback.call(this.callbackThis,g)}}class b{constructor(g){var S,M,y,R,F;this._disposed=!1,this._options=g,this._leakageMon=e>0||!((S=this._options)===null||S===void 0)&&S.leakWarningThreshold?new h((y=(M=this._options)===null||M===void 0?void 0:M.leakWarningThreshold)!==null&&y!==void 0?y:e):void 0,this._perfMon=!((R=this._options)===null||R===void 0)&&R._profName?new _(this._options._profName):void 0,this._deliveryQueue=(F=this._options)===null||F===void 0?void 0:F.deliveryQueue}dispose(){var g,S,M,y;if(!this._disposed){if(this._disposed=!0,this._listeners){if(L){const R=Array.from(this._listeners);queueMicrotask(()=>{var F;for(const U of R)U.subscription.isset()&&(U.subscription.unset(),(F=U.stack)===null||F===void 0||F.print())})}this._listeners.clear()}(g=this._deliveryQueue)===null||g===void 0||g.clear(this),(M=(S=this._options)===null||S===void 0?void 0:S.onDidRemoveLastListener)===null||M===void 0||M.call(S),(y=this._leakageMon)===null||y===void 0||y.dispose()}}get event(){return this._event||(this._event=(g,S,M)=>{var y,R,F;if(this._listeners||(this._listeners=new o.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const U=this._listeners.isEmpty();U&&(!((y=this._options)===null||y===void 0)&&y.onWillAddFirstListener)&&this._options.onWillAddFirstListener(this);let P,x;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(x=d.create(),P=this._leakageMon.check(x,this._listeners.size+1)),L&&(x=x??d.create());const W=new v(g,S,x),$=this._listeners.push(W);U&&(!((R=this._options)===null||R===void 0)&&R.onDidAddFirstListener)&&this._options.onDidAddFirstListener(this),!((F=this._options)===null||F===void 0)&&F.onDidAddListener&&this._options.onDidAddListener(this,g,S);const I=W.subscription.set(()=>{var T,q;P?.(),this._disposed||((q=(T=this._options)===null||T===void 0?void 0:T.onWillRemoveListener)===null||q===void 0||q.call(T,this),$(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof i.DisposableStore?M.add(I):Array.isArray(M)&&M.push(I),I}),this._event}fire(g){var S,M,y;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new N((S=this._options)===null||S===void 0?void 0:S.onListenerError));for(const R of this._listeners)this._deliveryQueue.push(this,R,g);(M=this._perfMon)===null||M===void 0||M.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(y=this._perfMon)===null||y===void 0||y.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=b;class p{constructor(g=E.onUnexpectedError){this._onListenerError=g,this._queue=new o.LinkedList}get size(){return this._queue.size}push(g,S,M){this._queue.push(new C(g,S,M))}clear(g){const S=new o.LinkedList;for(const M of this._queue)M.emitter!==g&&S.push(M);this._queue=S}deliver(){for(;this._queue.size>0;){const g=this._queue.shift();try{g.listener.invoke(g.event)}catch(S){this._onListenerError(S)}}}}n.EventDeliveryQueue=p;class N extends p{clear(g){this._queue.clear()}}class C{constructor(g,S,M){this.emitter=g,this.listener=S,this.event=M}}class A extends b{constructor(g){super(g),this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}n.PauseableEmitter=A;class w extends A{constructor(g){var S;super(g),this._delay=(S=g.delay)!==null&&S!==void 0?S:100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}n.DebounceEmitter=w;class u extends b{constructor(g){super(g),this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this.hasListeners()&&(this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=u;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const S={event:g,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const M=()=>{this.hasListeners&&this.unhook(S);const y=this.events.indexOf(S);this.events.splice(y,1)};return(0,i.toDisposable)((0,D.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(S=>this.emitter.fire(S))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=r;class l{constructor(){this.buffers=[]}wrapEvent(g){return(S,M,y)=>g(R=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>S.call(M,R)):S.call(M,R)},void 0,y)}bufferEvents(g){const S=[];this.buffers.push(S);const M=g();return this.buffers.pop(),S.forEach(y=>y()),M}}n.EventBufferer=l;class c{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new b({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=c}),J(Z[32],K([0,1,7]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(L,a){const s=setTimeout(L.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(L){function a(s){return s===L.None||s===L.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}L.isCancellationToken=a,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(n.CancellationToken=i={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class m{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){var s;a&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=m}),J(Z[5],K([0,1,27,31]),function(O,n,E,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function o(k){return!k||typeof k!="string"?!0:k.trim().length===0}n.isFalsyOrWhitespace=o;const m=/{(\d+)}/g;function L(k,...B){return B.length===0?k:k.replace(m,function(V,Y){const ee=parseInt(Y,10);return isNaN(ee)||ee<0||ee>=B.length?V:B[ee]})}n.format=L;function a(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=a;function s(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function _(k,B=" "){const V=e(k,B);return h(V,B)}n.trim=_;function e(k,B){if(!k||!B)return k;const V=B.length;if(V===0||k.length===0)return k;let Y=0;for(;k.indexOf(B,Y)===Y;)Y=Y+V;return k.substring(Y)}n.ltrim=e;function h(k,B){if(!k||!B)return k;const V=B.length,Y=k.length;if(V===0||Y===0)return k;let ee=Y,ae=-1;for(;ae=k.lastIndexOf(B,ee-1),!(ae===-1||ae+V!==ee);){if(ae===0)return"";ee=ae}return k.substring(0,ee)}n.rtrim=h;function d(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=d;function v(k){return k.replace(/\*/g,"")}n.stripWildcards=v;function b(k,B,V={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=s(k)),V.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let Y="";return V.global&&(Y+="g"),V.matchCase||(Y+="i"),V.multiline&&(Y+="m"),V.unicode&&(Y+="u"),new RegExp(k,Y)}n.createRegExp=b;function p(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}n.regExpLeadsToEndlessLoop=p;function N(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}n.regExpFlags=N;function C(k){return k.split(/\r\n|\r|\n/)}n.splitLines=C;function A(k){for(let B=0,V=k.length;B<V;B++){const Y=k.charCodeAt(B);if(Y!==32&&Y!==9)return B}return-1}n.firstNonWhitespaceIndex=A;function w(k,B=0,V=k.length){for(let Y=B;Y<V;Y++){const ee=k.charCodeAt(Y);if(ee!==32&&ee!==9)return k.substring(B,Y)}return k.substring(B,V)}n.getLeadingWhitespace=w;function u(k,B=k.length-1){for(let V=B;V>=0;V--){const Y=k.charCodeAt(V);if(Y!==32&&Y!==9)return V}return-1}n.lastNonWhitespaceIndex=u;function r(k,B){return k<B?-1:k>B?1:0}n.compare=r;function l(k,B,V=0,Y=k.length,ee=0,ae=B.length){for(;V<Y&&ee<ae;V++,ee++){const Ce=k.charCodeAt(V),oe=B.charCodeAt(ee);if(Ce<oe)return-1;if(Ce>oe)return 1}const fe=Y-V,ye=ae-ee;return fe<ye?-1:fe>ye?1:0}n.compareSubstring=l;function c(k,B){return f(k,B,0,k.length,0,B.length)}n.compareIgnoreCase=c;function f(k,B,V=0,Y=k.length,ee=0,ae=B.length){for(;V<Y&&ee<ae;V++,ee++){let Ce=k.charCodeAt(V),oe=B.charCodeAt(ee);if(Ce===oe)continue;if(Ce>=128||oe>=128)return l(k.toLowerCase(),B.toLowerCase(),V,Y,ee,ae);S(Ce)&&(Ce-=32),S(oe)&&(oe-=32);const be=Ce-oe;if(be!==0)return be}const fe=Y-V,ye=ae-ee;return fe<ye?-1:fe>ye?1:0}n.compareSubstringIgnoreCase=f;function g(k){return k>=48&&k<=57}n.isAsciiDigit=g;function S(k){return k>=97&&k<=122}n.isLowerAsciiLetter=S;function M(k){return k>=65&&k<=90}n.isUpperAsciiLetter=M;function y(k,B){return k.length===B.length&&f(k,B)===0}n.equalsIgnoreCase=y;function R(k,B){const V=B.length;return B.length>k.length?!1:f(k,B,0,V)===0}n.startsWithIgnoreCase=R;function F(k,B){const V=Math.min(k.length,B.length);let Y;for(Y=0;Y<V;Y++)if(k.charCodeAt(Y)!==B.charCodeAt(Y))return Y;return V}n.commonPrefixLength=F;function U(k,B){const V=Math.min(k.length,B.length);let Y;const ee=k.length-1,ae=B.length-1;for(Y=0;Y<V;Y++)if(k.charCodeAt(ee-Y)!==B.charCodeAt(ae-Y))return Y;return V}n.commonSuffixLength=U;function P(k){return 55296<=k&&k<=56319}n.isHighSurrogate=P;function x(k){return 56320<=k&&k<=57343}n.isLowSurrogate=x;function W(k,B){return(k-55296<<10)+(B-56320)+65536}n.computeCodePoint=W;function $(k,B,V){const Y=k.charCodeAt(V);if(P(Y)&&V+1<B){const ee=k.charCodeAt(V+1);if(x(ee))return W(Y,ee)}return Y}n.getNextCodePoint=$;function I(k,B){const V=k.charCodeAt(B-1);if(x(V)&&B>1){const Y=k.charCodeAt(B-2);if(P(Y))return W(Y,V)}return V}class T{get offset(){return this._offset}constructor(B,V=0){this._str=B,this._len=B.length,this._offset=V}setOffset(B){this._offset=B}prevCodePoint(){const B=I(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=$(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=T;class q{get offset(){return this._iterator.offset}constructor(B,V=0){this._iterator=new T(B,V)}nextGraphemeLength(){const B=X.getInstance(),V=this._iterator,Y=V.offset;let ee=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ae=V.offset,fe=B.getGraphemeBreakType(V.nextCodePoint());if(G(ee,fe)){V.setOffset(ae);break}ee=fe}return V.offset-Y}prevGraphemeLength(){const B=X.getInstance(),V=this._iterator,Y=V.offset;let ee=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ae=V.offset,fe=B.getGraphemeBreakType(V.prevCodePoint());if(G(fe,ee)){V.setOffset(ae);break}ee=fe}return Y-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=q;function z(k,B){return new q(k,B).nextGraphemeLength()}n.nextCharLength=z;function t(k,B){return new q(k,B).prevGraphemeLength()}n.prevCharLength=t;function se(k,B){B>0&&x(k.charCodeAt(B))&&B--;const V=B+z(k,B);return[V-t(k,V),V]}n.getCharContainingOffset=se;let ne;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ge(k){return ne||(ne=ce()),ne.test(k)}n.containsRTL=ge;const me=/^[\t\n\r\x20-\x7E]*$/;function _e(k){return me.test(k)}n.isBasicASCII=_e,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ve(k){return n.UNUSUAL_LINE_TERMINATORS.test(k)}n.containsUnusualLineTerminators=ve;function Le(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}n.isFullWidthCharacter=Le;function re(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}n.isEmojiImprecise=re,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}n.startsWithUTF8BOM=j;function H(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}n.containsUppercaseCharacter=H;function Q(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}n.singleLetterHash=Q;function G(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}class X{static getInstance(){return X._INSTANCE||(X._INSTANCE=new X),X._INSTANCE}constructor(){this._data=te()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this._data,Y=V.length/3;let ee=1;for(;ee<=Y;)if(B<V[3*ee])ee=2*ee;else if(B>V[3*ee+1])ee=2*ee+1;else return V[3*ee+2];return 0}}X._INSTANCE=null;function te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ie(k,B){if(k===0)return 0;const V=he(k,B);if(V!==void 0)return V;const Y=new T(B,k);return Y.prevCodePoint(),Y.offset}n.getLeftDeleteOffset=ie;function he(k,B){const V=new T(B,k);let Y=V.prevCodePoint();for(;Se(Y)||Y===65039||Y===8419;){if(V.offset===0)return;Y=V.prevCodePoint()}if(!re(Y))return;let ee=V.offset;return ee>0&&V.prevCodePoint()===8205&&(ee=V.offset),ee}function Se(k){return 127995<=k&&k<=127999}n.noBreakWhitespace="\xA0";class ue{static getInstance(B){return ue.cache.get(Array.from(B))}static getLocales(){return ue._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ue,i=ue,ue.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.cache=new E.LRUCachedFunction(k=>{function B(oe){const be=new Map;for(let we=0;we<oe.length;we+=2)be.set(oe[we],oe[we+1]);return be}function V(oe,be){const we=new Map(oe);for(const[Ae,Ne]of be)we.set(Ae,Ne);return we}function Y(oe,be){if(!oe)return be;const we=new Map;for(const[Ae,Ne]of oe)be.has(Ae)&&we.set(Ae,Ne);return we}const ee=i.ambiguousCharacterData.value;let ae=k.filter(oe=>!oe.startsWith("_")&&oe in ee);ae.length===0&&(ae=["_default"]);let fe;for(const oe of ae){const be=B(ee[oe]);fe=Y(fe,be)}const ye=B(ee._common),Ce=V(ye,fe);return new ue(Ce)}),ue._locales=new D.Lazy(()=>Object.keys(ue.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class pe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(pe.getRawData())),this._data}static isInvisibleCharacter(B){return pe.getData().has(B)}static get codePoints(){return pe.getData()}}n.InvisibleCharacters=pe,pe._data=void 0}),J(Z[33],K([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(b){return i(b,0)}n.hash=D;function i(b,p){switch(typeof b){case"object":return b===null?o(349,p):Array.isArray(b)?a(b,p):s(b,p);case"string":return L(b,p);case"boolean":return m(b,p);case"number":return o(b,p);case"undefined":return o(937,p);default:return o(617,p)}}n.doHash=i;function o(b,p){return(p<<5)-p+b|0}n.numberHash=o;function m(b,p){return o(b?433:863,p)}function L(b,p){p=o(149417,p);for(let N=0,C=b.length;N<C;N++)p=o(b.charCodeAt(N),p);return p}n.stringHash=L;function a(b,p){return p=o(104579,p),b.reduce((N,C)=>i(C,N),p)}function s(b,p){return p=o(181387,p),Object.keys(b).sort().reduce((N,C)=>(N=L(C,N),i(b[C],N)),p)}function _(b,p,N=32){const C=N-p,A=~((1<<C)-1);return(b<<p|(A&b)>>>C)>>>0}function e(b,p=0,N=b.byteLength,C=0){for(let A=0;A<N;A++)b[p+A]=C}function h(b,p,N="0"){for(;b.length<p;)b=N+b;return b}function d(b,p=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(N=>N.toString(16).padStart(2,"0")).join(""):h((b>>>0).toString(16),p/4)}n.toHexString=d;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const N=p.length;if(N===0)return;const C=this._buff;let A=this._buffLen,w=this._leftoverHighSurrogate,u,r;for(w!==0?(u=w,r=-1,w=0):(u=p.charCodeAt(0),r=0);;){let l=u;if(E.isHighSurrogate(u))if(r+1<N){const c=p.charCodeAt(r+1);E.isLowSurrogate(c)?(r++,l=E.computeCodePoint(u,c)):l=65533}else{w=u;break}else E.isLowSurrogate(u)&&(l=65533);if(A=this._push(C,A,l),r++,r<N)u=p.charCodeAt(r);else break}this._buffLen=A,this._leftoverHighSurrogate=w}_push(p,N,C){return C<128?p[N++]=C:C<2048?(p[N++]=192|(C&1984)>>>6,p[N++]=128|(C&63)>>>0):C<65536?(p[N++]=224|(C&61440)>>>12,p[N++]=128|(C&4032)>>>6,p[N++]=128|(C&63)>>>0):(p[N++]=240|(C&1835008)>>>18,p[N++]=128|(C&258048)>>>12,p[N++]=128|(C&4032)>>>6,p[N++]=128|(C&63)>>>0),N>=64&&(this._step(),N-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),N}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=v._bigBlock32,N=this._buffDV;for(let g=0;g<64;g+=4)p.setUint32(g,N.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)p.setUint32(g,_(p.getUint32(g-12,!1)^p.getUint32(g-32,!1)^p.getUint32(g-56,!1)^p.getUint32(g-64,!1),1),!1);let C=this._h0,A=this._h1,w=this._h2,u=this._h3,r=this._h4,l,c,f;for(let g=0;g<80;g++)g<20?(l=A&w|~A&u,c=1518500249):g<40?(l=A^w^u,c=1859775393):g<60?(l=A&w|A&u|w&u,c=2400959708):(l=A^w^u,c=3395469782),f=_(C,5)+l+r+c+p.getUint32(g*4,!1)&4294967295,r=u,u=w,w=_(A,30),A=C,C=f;this._h0=this._h0+C&4294967295,this._h1=this._h1+A&4294967295,this._h2=this._h2+w&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),J(Z[19],K([0,1,29,33]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,h=new Int32Array(e.length);for(let d=0,v=e.length;d<v;d++)h[d]=e.charCodeAt(d);return h}}n.StringDiffSequence=i;function o(_,e,h){return new s(new i(_),new i(e)).ComputeDiff(h).changes}n.stringDiff=o;class m{static Assert(e,h){if(!e)throw new Error(h)}}class L{static Copy(e,h,d,v,b){for(let p=0;p<b;p++)d[v+p]=e[h+p]}static Copy2(e,h,d,v,b){for(let p=0;p<b;p++)d[v+p]=e[h+p]}}class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,h){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_originalCount++}AddModifiedElement(e,h){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,h,d=null){this.ContinueProcessingPredicate=d,this._originalSequence=e,this._modifiedSequence=h;const[v,b,p]=s._getElements(e),[N,C,A]=s._getElements(h);this._hasStrings=p&&A,this._originalStringElements=v,this._originalElementsOrHash=b,this._modifiedStringElements=N,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const h=e.getElements();if(s._isStringArray(h)){const d=new Int32Array(h.length);for(let v=0,b=h.length;v<b;v++)d[v]=(0,D.stringHash)(h[v],0);return[h,d,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}ElementsAreEqual(e,h){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[h]:!0}ElementsAreStrictEqual(e,h){if(!this.ElementsAreEqual(e,h))return!1;const d=s._getStrictElement(this._originalSequence,e),v=s._getStrictElement(this._modifiedSequence,h);return d===v}static _getStrictElement(e,h){return typeof e.getStrictElement=="function"?e.getStrictElement(h):null}OriginalElementsAreEqual(e,h){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[h]:!0}ModifiedElementsAreEqual(e,h){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[h]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,h,d,v,b){const p=[!1];let N=this.ComputeDiffRecursive(e,h,d,v,p);return b&&(N=this.PrettifyChanges(N)),{quitEarly:p[0],changes:N}}ComputeDiffRecursive(e,h,d,v,b){for(b[0]=!1;e<=h&&d<=v&&this.ElementsAreEqual(e,d);)e++,d++;for(;h>=e&&v>=d&&this.ElementsAreEqual(h,v);)h--,v--;if(e>h||d>v){let u;return d<=v?(m.Assert(e===h+1,"originalStart should only be one more than originalEnd"),u=[new E.DiffChange(e,0,d,v-d+1)]):e<=h?(m.Assert(d===v+1,"modifiedStart should only be one more than modifiedEnd"),u=[new E.DiffChange(e,h-e+1,d,0)]):(m.Assert(e===h+1,"originalStart should only be one more than originalEnd"),m.Assert(d===v+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const p=[0],N=[0],C=this.ComputeRecursionPoint(e,h,d,v,p,N,b),A=p[0],w=N[0];if(C!==null)return C;if(!b[0]){const u=this.ComputeDiffRecursive(e,A,d,w,b);let r=[];return b[0]?r=[new E.DiffChange(A+1,h-(A+1)+1,w+1,v-(w+1)+1)]:r=this.ComputeDiffRecursive(A+1,h,w+1,v,b),this.ConcatenateChanges(u,r)}return[new E.DiffChange(e,h-e+1,d,v-d+1)]}WALKTRACE(e,h,d,v,b,p,N,C,A,w,u,r,l,c,f,g,S,M){let y=null,R=null,F=new a,U=h,P=d,x=l[0]-g[0]-v,W=-1073741824,$=this.m_forwardHistory.length-1;do{const I=x+e;I===U||I<P&&A[I-1]<A[I+1]?(u=A[I+1],c=u-x-v,u<W&&F.MarkNextChange(),W=u,F.AddModifiedElement(u+1,c),x=I+1-e):(u=A[I-1]+1,c=u-x-v,u<W&&F.MarkNextChange(),W=u-1,F.AddOriginalElement(u,c+1),x=I-1-e),$>=0&&(A=this.m_forwardHistory[$],e=A[0],U=1,P=A.length-1)}while(--$>=-1);if(y=F.getReverseChanges(),M[0]){let I=l[0]+1,T=g[0]+1;if(y!==null&&y.length>0){const q=y[y.length-1];I=Math.max(I,q.getOriginalEnd()),T=Math.max(T,q.getModifiedEnd())}R=[new E.DiffChange(I,r-I+1,T,f-T+1)]}else{F=new a,U=p,P=N,x=l[0]-g[0]-C,W=1073741824,$=S?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const I=x+b;I===U||I<P&&w[I-1]>=w[I+1]?(u=w[I+1]-1,c=u-x-C,u>W&&F.MarkNextChange(),W=u+1,F.AddOriginalElement(u+1,c+1),x=I+1-b):(u=w[I-1],c=u-x-C,u>W&&F.MarkNextChange(),W=u,F.AddModifiedElement(u+1,c+1),x=I-1-b),$>=0&&(w=this.m_reverseHistory[$],b=w[0],U=1,P=w.length-1)}while(--$>=-1);R=F.getChanges()}return this.ConcatenateChanges(y,R)}ComputeRecursionPoint(e,h,d,v,b,p,N){let C=0,A=0,w=0,u=0,r=0,l=0;e--,d--,b[0]=0,p[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const c=h-e+(v-d),f=c+1,g=new Int32Array(f),S=new Int32Array(f),M=v-d,y=h-e,R=e-d,F=h-v,P=(y-M)%2===0;g[M]=e,S[y]=h,N[0]=!1;for(let x=1;x<=c/2+1;x++){let W=0,$=0;w=this.ClipDiagonalBound(M-x,x,M,f),u=this.ClipDiagonalBound(M+x,x,M,f);for(let T=w;T<=u;T+=2){T===w||T<u&&g[T-1]<g[T+1]?C=g[T+1]:C=g[T-1]+1,A=C-(T-M)-R;const q=C;for(;C<h&&A<v&&this.ElementsAreEqual(C+1,A+1);)C++,A++;if(g[T]=C,C+A>W+$&&(W=C,$=A),!P&&Math.abs(T-y)<=x-1&&C>=S[T])return b[0]=C,p[0]=A,q<=S[T]&&1447>0&&x<=1447+1?this.WALKTRACE(M,w,u,R,y,r,l,F,g,S,C,h,b,A,v,p,P,N):null}const I=(W-e+($-d)-x)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(W,I))return N[0]=!0,b[0]=W,p[0]=$,I>0&&1447>0&&x<=1447+1?this.WALKTRACE(M,w,u,R,y,r,l,F,g,S,C,h,b,A,v,p,P,N):(e++,d++,[new E.DiffChange(e,h-e+1,d,v-d+1)]);r=this.ClipDiagonalBound(y-x,x,y,f),l=this.ClipDiagonalBound(y+x,x,y,f);for(let T=r;T<=l;T+=2){T===r||T<l&&S[T-1]>=S[T+1]?C=S[T+1]-1:C=S[T-1],A=C-(T-y)-F;const q=C;for(;C>e&&A>d&&this.ElementsAreEqual(C,A);)C--,A--;if(S[T]=C,P&&Math.abs(T-M)<=x&&C<=g[T])return b[0]=C,p[0]=A,q>=g[T]&&1447>0&&x<=1447+1?this.WALKTRACE(M,w,u,R,y,r,l,F,g,S,C,h,b,A,v,p,P,N):null}if(x<=1447){let T=new Int32Array(u-w+2);T[0]=M-w+1,L.Copy2(g,w,T,1,u-w+1),this.m_forwardHistory.push(T),T=new Int32Array(l-r+2),T[0]=y-r+1,L.Copy2(S,r,T,1,l-r+1),this.m_reverseHistory.push(T)}}return this.WALKTRACE(M,w,u,R,y,r,l,F,g,S,C,h,b,A,v,p,P,N)}PrettifyChanges(e){for(let h=0;h<e.length;h++){const d=e[h],v=h<e.length-1?e[h+1].originalStart:this._originalElementsOrHash.length,b=h<e.length-1?e[h+1].modifiedStart:this._modifiedElementsOrHash.length,p=d.originalLength>0,N=d.modifiedLength>0;for(;d.originalStart+d.originalLength<v&&d.modifiedStart+d.modifiedLength<b&&(!p||this.OriginalElementsAreEqual(d.originalStart,d.originalStart+d.originalLength))&&(!N||this.ModifiedElementsAreEqual(d.modifiedStart,d.modifiedStart+d.modifiedLength));){const A=this.ElementsAreStrictEqual(d.originalStart,d.modifiedStart);if(this.ElementsAreStrictEqual(d.originalStart+d.originalLength,d.modifiedStart+d.modifiedLength)&&!A)break;d.originalStart++,d.modifiedStart++}const C=[null];if(h<e.length-1&&this.ChangesOverlap(e[h],e[h+1],C)){e[h]=C[0],e.splice(h+1,1),h--;continue}}for(let h=e.length-1;h>=0;h--){const d=e[h];let v=0,b=0;if(h>0){const u=e[h-1];v=u.originalStart+u.originalLength,b=u.modifiedStart+u.modifiedLength}const p=d.originalLength>0,N=d.modifiedLength>0;let C=0,A=this._boundaryScore(d.originalStart,d.originalLength,d.modifiedStart,d.modifiedLength);for(let u=1;;u++){const r=d.originalStart-u,l=d.modifiedStart-u;if(r<v||l<b||p&&!this.OriginalElementsAreEqual(r,r+d.originalLength)||N&&!this.ModifiedElementsAreEqual(l,l+d.modifiedLength))break;const f=(r===v&&l===b?5:0)+this._boundaryScore(r,d.originalLength,l,d.modifiedLength);f>A&&(A=f,C=u)}d.originalStart-=C,d.modifiedStart-=C;const w=[null];if(h>0&&this.ChangesOverlap(e[h-1],e[h],w)){e[h-1]=w[0],e.splice(h,1),h++;continue}}if(this._hasStrings)for(let h=1,d=e.length;h<d;h++){const v=e[h-1],b=e[h],p=b.originalStart-v.originalStart-v.originalLength,N=v.originalStart,C=b.originalStart+b.originalLength,A=C-N,w=v.modifiedStart,u=b.modifiedStart+b.modifiedLength,r=u-w;if(p<5&&A<20&&r<20){const l=this._findBetterContiguousSequence(N,A,w,r,p);if(l){const[c,f]=l;(c!==v.originalStart+v.originalLength||f!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=c-v.originalStart,v.modifiedLength=f-v.modifiedStart,b.originalStart=c+p,b.modifiedStart=f+p,b.originalLength=C-b.originalStart,b.modifiedLength=u-b.modifiedStart)}}}return e}_findBetterContiguousSequence(e,h,d,v,b){if(h<b||v<b)return null;const p=e+h-b+1,N=d+v-b+1;let C=0,A=0,w=0;for(let u=e;u<p;u++)for(let r=d;r<N;r++){const l=this._contiguousSequenceScore(u,r,b);l>0&&l>C&&(C=l,A=u,w=r)}return C>0?[A,w]:null}_contiguousSequenceScore(e,h,d){let v=0;for(let b=0;b<d;b++){if(!this.ElementsAreEqual(e+b,h+b))return 0;v+=this._originalStringElements[e+b].length}return v}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,h){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(h>0){const d=e+h;if(this._OriginalIsBoundary(d-1)||this._OriginalIsBoundary(d))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,h){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(h>0){const d=e+h;if(this._ModifiedIsBoundary(d-1)||this._ModifiedIsBoundary(d))return!0}return!1}_boundaryScore(e,h,d,v){const b=this._OriginalRegionIsBoundary(e,h)?1:0,p=this._ModifiedRegionIsBoundary(d,v)?1:0;return b+p}ConcatenateChanges(e,h){const d=[];if(e.length===0||h.length===0)return h.length>0?h:e;if(this.ChangesOverlap(e[e.length-1],h[0],d)){const v=new Array(e.length+h.length-1);return L.Copy(e,0,v,0,e.length-1),v[e.length-1]=d[0],L.Copy(h,1,v,e.length,h.length-1),v}else{const v=new Array(e.length+h.length);return L.Copy(e,0,v,0,e.length),L.Copy(h,0,v,e.length,h.length),v}}ChangesOverlap(e,h,d){if(m.Assert(e.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),m.Assert(e.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=h.originalStart||e.modifiedStart+e.modifiedLength>=h.modifiedStart){const v=e.originalStart;let b=e.originalLength;const p=e.modifiedStart;let N=e.modifiedLength;return e.originalStart+e.originalLength>=h.originalStart&&(b=h.originalStart+h.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=h.modifiedStart&&(N=h.modifiedStart+h.modifiedLength-e.modifiedStart),d[0]=new E.DiffChange(v,b,p,N),!0}else return d[0]=null,!1}ClipDiagonalBound(e,h,d,v){if(e>=0&&e<v)return e;const b=d,p=v-d-1,N=h%2===0;if(e<0){const C=b%2===0;return N===C?0:1}else{const C=p%2===0;return N===C?v-1:v-2}}}n.LcsDiff=s}),J(Z[20],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(C){return typeof C=="string"}n.isString=E;function D(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}n.isObject=D;function i(C){const A=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof A}n.isTypedArray=i;function o(C){return typeof C=="number"&&!isNaN(C)}n.isNumber=o;function m(C){return!!C&&typeof C[Symbol.iterator]=="function"}n.isIterable=m;function L(C){return C===!0||C===!1}n.isBoolean=L;function a(C){return typeof C>"u"}n.isUndefined=a;function s(C){return!_(C)}n.isDefined=s;function _(C){return a(C)||C===null}n.isUndefinedOrNull=_;function e(C,A){if(!C)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}n.assertType=e;function h(C){if(_(C))throw new Error("Assertion Failed: argument is undefined or null");return C}n.assertIsDefined=h;function d(C){return typeof C=="function"}n.isFunction=d;function v(C,A){const w=Math.min(C.length,A.length);for(let u=0;u<w;u++)b(C[u],A[u])}n.validateConstraints=v;function b(C,A){if(E(A)){if(typeof C!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(d(A)){try{if(C instanceof A)return}catch{}if(!_(C)&&C.constructor===A||A.length===1&&A.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function p(C){return C===null?void 0:C}n.withNullAsUndefined=p;function N(C){return typeof C>"u"?null:C}n.withUndefinedAsNull=N}),J(Z[34],K([0,1,20]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(m,L){if((0,E.isString)(L)){const a=D[L];if(a===void 0)throw new Error(`${m} references an unknown codicon: ${L}`);L=a}return D[m]=L,{id:m}}function o(){return D}n.getCodiconFontCharacters=o,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(Z[11],K([0,1,20]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([b,p])=>{v[b]=p&&typeof p=="object"?D(p):p}),v}n.deepClone=D;function i(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const b=v.shift();Object.freeze(b);for(const p in b)if(o.call(b,p)){const N=b[p];typeof N=="object"&&!Object.isFrozen(N)&&!(0,E.isTypedArray)(N)&&v.push(N)}}return d}n.deepFreeze=i;const o=Object.prototype.hasOwnProperty;function m(d,v){return L(d,v,new Set)}n.cloneAndChange=m;function L(d,v,b){if((0,E.isUndefinedOrNull)(d))return d;const p=v(d);if(typeof p<"u")return p;if(Array.isArray(d)){const N=[];for(const C of d)N.push(L(C,v,b));return N}if((0,E.isObject)(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const N={};for(const C in d)o.call(d,C)&&(N[C]=L(d[C],v,b));return b.delete(d),N}return d}function a(d,v,b=!0){return(0,E.isObject)(d)?((0,E.isObject)(v)&&Object.keys(v).forEach(p=>{p in d?b&&((0,E.isObject)(d[p])&&(0,E.isObject)(v[p])?a(d[p],v[p],b):d[p]=v[p]):d[p]=v[p]}),d):v}n.mixin=a;function s(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let b,p;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(b=0;b<d.length;b++)if(!s(d[b],v[b]))return!1}else{const N=[];for(p in d)N.push(p);N.sort();const C=[];for(p in v)C.push(p);if(C.sort(),!s(N,C))return!1;for(b=0;b<N.length;b++)if(!s(d[N[b]],v[N[b]]))return!1}return!0}n.equals=s;function _(d){let v=[],b=Object.getPrototypeOf(d);for(;Object.prototype!==b;)v=v.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return v}n.getAllPropertyNames=_;function e(d){const v=[];for(const b of _(d))typeof d[b]=="function"&&v.push(b);return v}n.getAllMethodNames=e;function h(d,v){const b=N=>function(){const C=Array.prototype.slice.call(arguments,0);return v(N,C)},p={};for(const N of d)p[N]=b(N);return p}n.createProxyObject=h}),J(Z[21],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),J(Z[22],K([0,1,21]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(m){const L=(0,E.toUint8)(m);this._defaultValue=L,this._asciiMap=D._createAsciiMap(L),this._map=new Map}static _createAsciiMap(m){const L=new Uint8Array(256);return L.fill(m),L}set(m,L){const a=(0,E.toUint8)(L);m>=0&&m<256?this._asciiMap[m]=a:this._map.set(m,a)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class i{constructor(){this._actual=new D(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),J(Z[6],K([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=void 0;class D{static addRange(o,m){let L=0;for(;L<m.length&&m[L].endExclusive<o.start;)L++;let a=L;for(;a<m.length&&m[a].start<=o.endExclusive;)a++;if(L===a)m.splice(L,0,o);else{const s=Math.min(o.start,m[L].start),_=Math.max(o.endExclusive,m[a-1].endExclusive);m.splice(L,a-L,new D(s,_))}}static tryCreate(o,m){if(!(o>m))return new D(o,m)}constructor(o,m){if(this.start=o,this.endExclusive=m,o>m)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(o){return new D(this.start+o,this.endExclusive+o)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(o){return this.start===o.start&&this.endExclusive===o.endExclusive}containsRange(o){return this.start<=o.start&&o.endExclusive<=this.endExclusive}join(o){return new D(Math.min(this.start,o.start),Math.max(this.endExclusive,o.endExclusive))}intersect(o){const m=Math.max(this.start,o.start),L=Math.min(this.endExclusive,o.endExclusive);if(m<=L)return new D(m,L)}}n.OffsetRange=D}),J(Z[3],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new E(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return E.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const m=i.lineNumber|0,L=o.lineNumber|0;if(m===L){const a=i.column|0,s=o.column|0;return a-s}return m-L}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),J(Z[2],K([0,1,3]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(o,m,L,a){o>L||o===L&&m>a?(this.startLineNumber=L,this.startColumn=a,this.endLineNumber=o,this.endColumn=m):(this.startLineNumber=o,this.startColumn=m,this.endLineNumber=L,this.endColumn=a)}isEmpty(){return D.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return D.containsPosition(this,o)}static containsPosition(o,m){return!(m.lineNumber<o.startLineNumber||m.lineNumber>o.endLineNumber||m.lineNumber===o.startLineNumber&&m.column<o.startColumn||m.lineNumber===o.endLineNumber&&m.column>o.endColumn)}static strictContainsPosition(o,m){return!(m.lineNumber<o.startLineNumber||m.lineNumber>o.endLineNumber||m.lineNumber===o.startLineNumber&&m.column<=o.startColumn||m.lineNumber===o.endLineNumber&&m.column>=o.endColumn)}containsRange(o){return D.containsRange(this,o)}static containsRange(o,m){return!(m.startLineNumber<o.startLineNumber||m.endLineNumber<o.startLineNumber||m.startLineNumber>o.endLineNumber||m.endLineNumber>o.endLineNumber||m.startLineNumber===o.startLineNumber&&m.startColumn<o.startColumn||m.endLineNumber===o.endLineNumber&&m.endColumn>o.endColumn)}strictContainsRange(o){return D.strictContainsRange(this,o)}static strictContainsRange(o,m){return!(m.startLineNumber<o.startLineNumber||m.endLineNumber<o.startLineNumber||m.startLineNumber>o.endLineNumber||m.endLineNumber>o.endLineNumber||m.startLineNumber===o.startLineNumber&&m.startColumn<=o.startColumn||m.endLineNumber===o.endLineNumber&&m.endColumn>=o.endColumn)}plusRange(o){return D.plusRange(this,o)}static plusRange(o,m){let L,a,s,_;return m.startLineNumber<o.startLineNumber?(L=m.startLineNumber,a=m.startColumn):m.startLineNumber===o.startLineNumber?(L=m.startLineNumber,a=Math.min(m.startColumn,o.startColumn)):(L=o.startLineNumber,a=o.startColumn),m.endLineNumber>o.endLineNumber?(s=m.endLineNumber,_=m.endColumn):m.endLineNumber===o.endLineNumber?(s=m.endLineNumber,_=Math.max(m.endColumn,o.endColumn)):(s=o.endLineNumber,_=o.endColumn),new D(L,a,s,_)}intersectRanges(o){return D.intersectRanges(this,o)}static intersectRanges(o,m){let L=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,_=o.endColumn;const e=m.startLineNumber,h=m.startColumn,d=m.endLineNumber,v=m.endColumn;return L<e?(L=e,a=h):L===e&&(a=Math.max(a,h)),s>d?(s=d,_=v):s===d&&(_=Math.min(_,v)),L>s||L===s&&a>_?null:new D(L,a,s,_)}equalsRange(o){return D.equalsRange(this,o)}static equalsRange(o,m){return!o&&!m?!0:!!o&&!!m&&o.startLineNumber===m.startLineNumber&&o.startColumn===m.startColumn&&o.endLineNumber===m.endLineNumber&&o.endColumn===m.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(o){return new E.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(o){return new E.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,m){return new D(this.startLineNumber,this.startColumn,o,m)}setStartPosition(o,m){return new D(o,m,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(o){return new D(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(o){return new D(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new D(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,m=o){return new D(o.lineNumber,o.column,m.lineNumber,m.column)}static lift(o){return o?new D(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,m){return!(o.endLineNumber<m.startLineNumber||o.endLineNumber===m.startLineNumber&&o.endColumn<m.startColumn||m.endLineNumber<o.startLineNumber||m.endLineNumber===o.startLineNumber&&m.endColumn<o.startColumn)}static areIntersecting(o,m){return!(o.endLineNumber<m.startLineNumber||o.endLineNumber===m.startLineNumber&&o.endColumn<=m.startColumn||m.endLineNumber<o.startLineNumber||m.endLineNumber===o.startLineNumber&&m.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,m){if(o&&m){const s=o.startLineNumber|0,_=m.startLineNumber|0;if(s===_){const e=o.startColumn|0,h=m.startColumn|0;if(e===h){const d=o.endLineNumber|0,v=m.endLineNumber|0;if(d===v){const b=o.endColumn|0,p=m.endColumn|0;return b-p}return d-v}return e-h}return s-_}return(o?1:0)-(m?1:0)}static compareRangesUsingEnds(o,m){return o.endLineNumber===m.endLineNumber?o.endColumn===m.endColumn?o.startLineNumber===m.startLineNumber?o.startColumn-m.startColumn:o.startLineNumber-m.startLineNumber:o.endColumn-m.endColumn:o.endLineNumber-m.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}n.Range=D}),J(Z[12],K([0,1,4,2]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class i{static fromRange(m){return new i(m.startLineNumber,m.endLineNumber)}static subtract(m,L){return L?m.startLineNumber<L.startLineNumber&&L.endLineNumberExclusive<m.endLineNumberExclusive?[new i(m.startLineNumber,L.startLineNumber),new i(L.endLineNumberExclusive,m.endLineNumberExclusive)]:L.startLineNumber<=m.startLineNumber&&m.endLineNumberExclusive<=L.endLineNumberExclusive?[]:L.endLineNumberExclusive<m.endLineNumberExclusive?[new i(Math.max(L.endLineNumberExclusive,m.startLineNumber),m.endLineNumberExclusive)]:[new i(m.startLineNumber,Math.min(L.startLineNumber,m.endLineNumberExclusive))]:[m]}static joinMany(m){if(m.length===0)return[];let L=m[0];for(let a=1;a<m.length;a++)L=this.join(L,m[a]);return L}static join(m,L){if(m.length===0)return L;if(L.length===0)return m;const a=[];let s=0,_=0,e=null;for(;s<m.length||_<L.length;){let h=null;if(s<m.length&&_<L.length){const d=m[s],v=L[_];d.startLineNumber<v.startLineNumber?(h=d,s++):(h=v,_++)}else s<m.length?(h=m[s],s++):(h=L[_],_++);e===null?e=h:e.endLineNumberExclusive>=h.startLineNumber?e=new i(e.startLineNumber,Math.max(e.endLineNumberExclusive,h.endLineNumberExclusive)):(a.push(e),e=h)}return e!==null&&a.push(e),a}static ofLength(m,L){return new i(m,m+L)}constructor(m,L){if(m>L)throw new E.BugIndicatingError(`startLineNumber ${m} cannot be after endLineNumberExclusive ${L}`);this.startLineNumber=m,this.endLineNumberExclusive=L}contains(m){return this.startLineNumber<=m&&m<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(m){return new i(this.startLineNumber+m,this.endLineNumberExclusive+m)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(m){return new i(Math.min(this.startLineNumber,m.startLineNumber),Math.max(this.endLineNumberExclusive,m.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(m){const L=Math.max(this.startLineNumber,m.startLineNumber),a=Math.min(this.endLineNumberExclusive,m.endLineNumberExclusive);if(L<=a)return new i(L,a)}intersectsStrict(m){return this.startLineNumber<m.endLineNumberExclusive&&m.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(m){return this.startLineNumber<=m.endLineNumberExclusive&&m.startLineNumber<=this.endLineNumberExclusive}equals(m){return this.startLineNumber===m.startLineNumber&&this.endLineNumberExclusive===m.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(m){const L=[];for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)L.push(m(a));return L}}n.LineRange=i}),J(Z[35],K([0,1,3,2]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(m,L,a,s){super(m,L,a,s),this.selectionStartLineNumber=m,this.selectionStartColumn=L,this.positionLineNumber=a,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return i.selectionsEqual(this,m)}static selectionsEqual(m,L){return m.selectionStartLineNumber===L.selectionStartLineNumber&&m.selectionStartColumn===L.selectionStartColumn&&m.positionLineNumber===L.positionLineNumber&&m.positionColumn===L.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,L){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,m,L):new i(m,L,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,L){return this.getDirection()===0?new i(m,L,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,m,L)}static fromPositions(m,L=m){return new i(m.lineNumber,m.column,L.lineNumber,L.column)}static fromRange(m,L){return L===0?new i(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new i(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new i(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,L){if(m&&!L||!m&&L)return!1;if(!m&&!L)return!0;if(m.length!==L.length)return!1;for(let a=0,s=m.length;a<s;a++)if(!this.selectionsEqual(m[a],L[a]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,L,a,s,_){return _===0?new i(m,L,a,s):new i(a,s,m,L)}}n.Selection=i}),J(Z[36],K([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends E.CharacterClassifier{constructor(m){super(0);for(let L=0,a=m.length;L<a;L++)this.set(m.charCodeAt(L),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(o){const m={};return L=>(m.hasOwnProperty(L)||(m[L]=o(L)),m[L])}n.getMapForWordSeparators=i(o=>new D(o))}),J(Z[23],K([0,1,16,17]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(_+="\\"+e);return _+="\\s]+)",new RegExp(_,"g")}n.DEFAULT_WORD_REGEXP=i();function o(s){let _=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)_=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),_=new RegExp(s.source,e)}return _.lastIndex=0,_}n.ensureValidWordDefinition=o;const m=new D.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function L(s,_,e,h,d){if(d||(d=E.Iterable.first(m)),e.length>d.maxLen){let C=s-d.maxLen/2;return C<0?C=0:h+=C,e=e.substring(C,s+d.maxLen/2),L(s,_,e,h,d)}const v=Date.now(),b=s-1-h;let p=-1,N=null;for(let C=1;!(Date.now()-v>=d.timeBudget);C++){const A=b-d.windowSize*C;_.lastIndex=Math.max(0,A);const w=a(_,e,b,p);if(!w&&N||(N=w,A<=0))break;p=A}if(N){const C={word:N[0],startColumn:h+1+N.index,endColumn:h+1+N.index+N[0].length};return _.lastIndex=0,C}return null}n.getWordAtText=L;function a(s,_,e,h){let d;for(;d=s.exec(_);){const v=d.index||0;if(v<=e&&s.lastIndex>=e)return d;if(h>0&&v>h)return null}return null}}),J(Z[8],K([0,1,4,6]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,_){return new i([new o(new D.OffsetRange(0,s.length),new D.OffsetRange(0,_.length))],!1)}static trivialTimedOut(s,_){return new i([new o(new D.OffsetRange(0,s.length),new D.OffsetRange(0,_.length))],!0)}constructor(s,_){this.diffs=s,this.hitTimeout=_}}n.DiffAlgorithmResult=i;class o{constructor(s,_){this.seq1Range=s,this.seq2Range=_}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new o(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}}n.SequenceDiff=o;class m{isValid(){return!0}}n.InfiniteTimeout=m,m.instance=new m;class L{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=L}),J(Z[37],K([0,1,6,8]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(s,_,e){let h=e;return h=m(s,_,h),h=L(s,_,h),h}n.optimizeSequenceDiffs=i;function o(s,_,e){const h=[];for(const d of e){const v=h[h.length-1];if(!v){h.push(d);continue}d.seq1Range.start-v.seq1Range.endExclusive<=2||d.seq2Range.start-v.seq2Range.endExclusive<=2?h[h.length-1]=new D.SequenceDiff(v.seq1Range.join(d.seq1Range),v.seq2Range.join(d.seq2Range)):h.push(d)}return h}n.smoothenSequenceDiffs=o;function m(s,_,e){const h=[];e.length>0&&h.push(e[0]);for(let d=1;d<e.length;d++){const v=h[h.length-1],b=e[d];if(b.seq1Range.isEmpty){let p=!0;const N=b.seq1Range.start-v.seq1Range.endExclusive;for(let C=1;C<=N;C++)if(_.getElement(b.seq2Range.start-C)!==_.getElement(b.seq2Range.endExclusive-C)){p=!1;break}if(p){h[h.length-1]=new D.SequenceDiff(v.seq1Range,new E.OffsetRange(v.seq2Range.start,b.seq2Range.endExclusive-N));continue}}h.push(b)}return h}n.joinSequenceDiffs=m;function L(s,_,e){if(!s.getBoundaryScore||!_.getBoundaryScore)return e;for(let h=0;h<e.length;h++){const d=e[h];if(d.seq1Range.isEmpty){const v=h>0?e[h-1].seq2Range.endExclusive:-1,b=h+1<e.length?e[h+1].seq2Range.start:_.length;e[h]=a(d,s,_,b,v)}else if(d.seq2Range.isEmpty){const v=h>0?e[h-1].seq1Range.endExclusive:-1,b=h+1<e.length?e[h+1].seq1Range.start:s.length;e[h]=a(d.reverse(),_,s,b,v).reverse()}}return e}n.shiftSequenceDiffs=L;function a(s,_,e,h,d){let b=1;for(;s.seq2Range.start-b>d&&e.getElement(s.seq2Range.start-b)===e.getElement(s.seq2Range.endExclusive-b)&&b<20;)b++;b--;let p=0;for(;s.seq2Range.start+p<h&&e.getElement(s.seq2Range.start+p)===e.getElement(s.seq2Range.endExclusive+p)&&p<20;)p++;if(b===0&&p===0)return s;let N=0,C=-1;for(let A=-b;A<=p;A++){const w=s.seq2Range.start+A,u=s.seq2Range.endExclusive+A,r=s.seq1Range.start+A,l=_.getBoundaryScore(r)+e.getBoundaryScore(w)+e.getBoundaryScore(u);l>C&&(C=l,N=A)}return N!==0?new D.SequenceDiff(s.seq1Range.delta(N),s.seq2Range.delta(N)):s}}),J(Z[38],K([0,1,6,8]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,_,e=D.InfiniteTimeout.instance){if(s.length===0||_.length===0)return D.DiffAlgorithmResult.trivial(s,_);function h(u,r){for(;u<s.length&&r<_.length&&s.getElement(u)===_.getElement(r);)u++,r++;return u}let d=0;const v=new m;v.set(0,h(0,0));const b=new L;b.set(0,v.get(0)===0?null:new o(null,0,0,v.get(0)));let p=0;e:for(;;)for(d++,p=-d;p<=d;p+=2){if(!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(s,_);const u=p===d?-1:v.get(p+1),r=p===-d?-1:v.get(p-1)+1,l=Math.min(Math.max(u,r),s.length),c=l-p,f=h(l,c);v.set(p,f);const g=l===u?b.get(p+1):b.get(p-1);if(b.set(p,f!==l?new o(g,l,c,f-l):g),v.get(p)===s.length&&v.get(p)-p===_.length)break e}let N=b.get(p);const C=[];let A=s.length,w=_.length;for(;;){const u=N?N.x+N.length:0,r=N?N.y+N.length:0;if((u!==A||r!==w)&&C.push(new D.SequenceDiff(new E.OffsetRange(u,A),new E.OffsetRange(r,w))),!N)break;A=N.x,w=N.y,N=N.prev}return C.reverse(),new D.DiffAlgorithmResult(C,!1)}}n.MyersDiffAlgorithm=i;class o{constructor(s,_,e,h){this.prev=s,this.x=_,this.y=e,this.length=h}}class m{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=_}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=_}}}class L{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){s<0?(s=-s-1,this.negativeArr[s]=_):this.positiveArr[s]=_}}}),J(Z[39],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,o){this.width=i,this.height=o,this.array=[],this.array=new Array(i*o)}get(i,o){return this.array[i+o*this.width]}set(i,o,m){this.array[i+o*this.width]=m}}n.Array2D=E}),J(Z[40],K([0,1,6,8,39]),function(O,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class o{compute(L,a,s=D.InfiniteTimeout.instance,_){if(L.length===0||a.length===0)return D.DiffAlgorithmResult.trivial(L,a);const e=new i.Array2D(L.length,a.length),h=new i.Array2D(L.length,a.length),d=new i.Array2D(L.length,a.length);for(let w=0;w<L.length;w++)for(let u=0;u<a.length;u++){if(!s.isValid())return D.DiffAlgorithmResult.trivialTimedOut(L,a);const r=w===0?0:e.get(w-1,u),l=u===0?0:e.get(w,u-1);let c;L.getElement(w)===a.getElement(u)?(w===0||u===0?c=0:c=e.get(w-1,u-1),w>0&&u>0&&h.get(w-1,u-1)===3&&(c+=d.get(w-1,u-1)),c+=_?_(w,u):1):c=-1;const f=Math.max(r,l,c);if(f===c){const g=w>0&&u>0?d.get(w-1,u-1):0;d.set(w,u,g+1),h.set(w,u,3)}else f===r?(d.set(w,u,0),h.set(w,u,1)):f===l&&(d.set(w,u,0),h.set(w,u,2));e.set(w,u,f)}const v=[];let b=L.length,p=a.length;function N(w,u){(w+1!==b||u+1!==p)&&v.push(new D.SequenceDiff(new E.OffsetRange(w+1,b),new E.OffsetRange(u+1,p))),b=w,p=u}let C=L.length-1,A=a.length-1;for(;C>=0&&A>=0;)h.get(C,A)===3?(N(C,A),C--,A--):h.get(C,A)===1?C--:A--;return N(-1,-1),v.reverse(),new D.DiffAlgorithmResult(v,!1)}}n.DynamicProgrammingDiffing=o}),J(Z[24],K([0,1,12]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class D{constructor(s,_,e){this.changes=s,this.moves=_,this.hitTimeout=e}}n.LinesDiff=D;class i{static inverse(s,_,e){const h=[];let d=1,v=1;for(const p of s){const N=new i(new E.LineRange(d,p.originalRange.startLineNumber),new E.LineRange(v,p.modifiedRange.startLineNumber),void 0);N.modifiedRange.isEmpty||h.push(N),d=p.originalRange.endLineNumberExclusive,v=p.modifiedRange.endLineNumberExclusive}const b=new i(new E.LineRange(d,_+1),new E.LineRange(v,e+1),void 0);return b.modifiedRange.isEmpty||h.push(b),h}constructor(s,_,e){this.originalRange=s,this.modifiedRange=_,this.innerChanges=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(_=>_.flip()))}}n.LineRangeMapping=i;class o{constructor(s,_){this.originalRange=s,this.modifiedRange=_}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}n.RangeMapping=o;class m{constructor(s,_){this.originalRange=s,this.modifiedRange=_}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new m(this.modifiedRange,this.originalRange)}}n.SimpleLineRangeMapping=m;class L{constructor(s,_){this.lineRangeMapping=s,this.changes=_}flip(){return new L(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=L}),J(Z[41],K([0,1,19,24,5,2,9,12]),function(O,n,E,D,i,o,m,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const a=3;class s{computeDiff(u,r,l){var c;const g=new p(u,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),S=[];let M=null;for(const y of g.changes){let R;y.originalEndLineNumber===0?R=new L.LineRange(y.originalStartLineNumber+1,y.originalStartLineNumber+1):R=new L.LineRange(y.originalStartLineNumber,y.originalEndLineNumber+1);let F;y.modifiedEndLineNumber===0?F=new L.LineRange(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):F=new L.LineRange(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let U=new D.LineRangeMapping(R,F,(c=y.charChanges)===null||c===void 0?void 0:c.map(P=>new D.RangeMapping(new o.Range(P.originalStartLineNumber,P.originalStartColumn,P.originalEndLineNumber,P.originalEndColumn),new o.Range(P.modifiedStartLineNumber,P.modifiedStartColumn,P.modifiedEndLineNumber,P.modifiedEndColumn))));M&&(M.modifiedRange.endLineNumberExclusive===U.modifiedRange.startLineNumber||M.originalRange.endLineNumberExclusive===U.originalRange.startLineNumber)&&(U=new D.LineRangeMapping(M.originalRange.join(U.originalRange),M.modifiedRange.join(U.modifiedRange),M.innerChanges&&U.innerChanges?M.innerChanges.concat(U.innerChanges):void 0),S.pop()),S.push(U),M=U}return(0,m.assertFn)(()=>(0,m.checkAdjacentItems)(S,(y,R)=>R.originalRange.startLineNumber-y.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-y.modifiedRange.endLineNumberExclusive&&y.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&y.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),new D.LinesDiff(S,[],g.quitEarly)}}n.SmartLinesDiffComputer=s;function _(w,u,r,l){return new E.LcsDiff(w,u,r).ComputeDiff(l)}class e{constructor(u){const r=[],l=[];for(let c=0,f=u.length;c<f;c++)r[c]=N(u[c],1),l[c]=C(u[c],1);this.lines=u,this._startColumns=r,this._endColumns=l}getElements(){const u=[];for(let r=0,l=this.lines.length;r<l;r++)u[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,r,l){const c=[],f=[],g=[];let S=0;for(let M=r;M<=l;M++){const y=this.lines[M],R=u?this._startColumns[M]:1,F=u?this._endColumns[M]:y.length+1;for(let U=R;U<F;U++)c[S]=y.charCodeAt(U-1),f[S]=M+1,g[S]=U,S++;!u&&M<l&&(c[S]=10,f[S]=M+1,g[S]=y.length+1,S++)}return new h(c,f,g)}}class h{constructor(u,r,l){this._charCodes=u,this._lineNumbers=r,this._columns=l}toString(){return"["+this._charCodes.map((u,r)=>(u===10?"\\n":String.fromCharCode(u))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(u,r){if(u<0||u>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(u){return u>0&&u===this._lineNumbers.length?this.getEndLineNumber(u-1):(this._assertIndex(u,this._lineNumbers),this._lineNumbers[u])}getEndLineNumber(u){return u===-1?this.getStartLineNumber(u+1):(this._assertIndex(u,this._lineNumbers),this._charCodes[u]===10?this._lineNumbers[u]+1:this._lineNumbers[u])}getStartColumn(u){return u>0&&u===this._columns.length?this.getEndColumn(u-1):(this._assertIndex(u,this._columns),this._columns[u])}getEndColumn(u){return u===-1?this.getStartColumn(u+1):(this._assertIndex(u,this._columns),this._charCodes[u]===10?1:this._columns[u]+1)}}class d{constructor(u,r,l,c,f,g,S,M){this.originalStartLineNumber=u,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=c,this.modifiedStartLineNumber=f,this.modifiedStartColumn=g,this.modifiedEndLineNumber=S,this.modifiedEndColumn=M}static createFromDiffChange(u,r,l){const c=r.getStartLineNumber(u.originalStart),f=r.getStartColumn(u.originalStart),g=r.getEndLineNumber(u.originalStart+u.originalLength-1),S=r.getEndColumn(u.originalStart+u.originalLength-1),M=l.getStartLineNumber(u.modifiedStart),y=l.getStartColumn(u.modifiedStart),R=l.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),F=l.getEndColumn(u.modifiedStart+u.modifiedLength-1);return new d(c,f,g,S,M,y,R,F)}}function v(w){if(w.length<=1)return w;const u=[w[0]];let r=u[0];for(let l=1,c=w.length;l<c;l++){const f=w[l],g=f.originalStart-(r.originalStart+r.originalLength),S=f.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(g,S)<a?(r.originalLength=f.originalStart+f.originalLength-r.originalStart,r.modifiedLength=f.modifiedStart+f.modifiedLength-r.modifiedStart):(u.push(f),r=f)}return u}class b{constructor(u,r,l,c,f){this.originalStartLineNumber=u,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=c,this.charChanges=f}static createFromDiffResult(u,r,l,c,f,g,S){let M,y,R,F,U;if(r.originalLength===0?(M=l.getStartLineNumber(r.originalStart)-1,y=0):(M=l.getStartLineNumber(r.originalStart),y=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(R=c.getStartLineNumber(r.modifiedStart)-1,F=0):(R=c.getStartLineNumber(r.modifiedStart),F=c.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),g&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&f()){const P=l.createCharSequence(u,r.originalStart,r.originalStart+r.originalLength-1),x=c.createCharSequence(u,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(P.getElements().length>0&&x.getElements().length>0){let W=_(P,x,f,!0).changes;S&&(W=v(W)),U=[];for(let $=0,I=W.length;$<I;$++)U.push(d.createFromDiffChange(W[$],P,x))}}return new b(M,y,R,F,U)}}class p{constructor(u,r,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=u,this.modifiedLines=r,this.original=new e(u),this.modified=new e(r),this.continueLineDiff=A(l.maxComputationTime),this.continueCharDiff=A(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const u=_(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=u.changes,l=u.quitEarly;if(this.shouldIgnoreTrimWhitespace){const S=[];for(let M=0,y=r.length;M<y;M++)S.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[M],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:S}}const c=[];let f=0,g=0;for(let S=-1,M=r.length;S<M;S++){const y=S+1<M?r[S+1]:null,R=y?y.originalStart:this.originalLines.length,F=y?y.modifiedStart:this.modifiedLines.length;for(;f<R&&g<F;){const U=this.originalLines[f],P=this.modifiedLines[g];if(U!==P){{let x=N(U,1),W=N(P,1);for(;x>1&&W>1;){const $=U.charCodeAt(x-2),I=P.charCodeAt(W-2);if($!==I)break;x--,W--}(x>1||W>1)&&this._pushTrimWhitespaceCharChange(c,f+1,1,x,g+1,1,W)}{let x=C(U,1),W=C(P,1);const $=U.length+1,I=P.length+1;for(;x<$&&W<I;){const T=U.charCodeAt(x-1),q=U.charCodeAt(W-1);if(T!==q)break;x++,W++}(x<$||W<I)&&this._pushTrimWhitespaceCharChange(c,f+1,x,$,g+1,W,I)}}f++,g++}y&&(c.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,y,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),f+=y.originalLength,g+=y.modifiedLength)}return{quitEarly:l,changes:c}}_pushTrimWhitespaceCharChange(u,r,l,c,f,g,S){if(this._mergeTrimWhitespaceCharChange(u,r,l,c,f,g,S))return;let M;this.shouldComputeCharChanges&&(M=[new d(r,l,r,c,f,g,f,S)]),u.push(new b(r,r,f,f,M))}_mergeTrimWhitespaceCharChange(u,r,l,c,f,g,S){const M=u.length;if(M===0)return!1;const y=u[M-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===r&&y.modifiedEndLineNumber===f?(this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new d(r,l,r,c,f,g,f,S)),!0):y.originalEndLineNumber+1===r&&y.modifiedEndLineNumber+1===f?(y.originalEndLineNumber=r,y.modifiedEndLineNumber=f,this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new d(r,l,r,c,f,g,f,S)),!0):!1}}n.DiffComputer=p;function N(w,u){const r=i.firstNonWhitespaceIndex(w);return r===-1?u:r+1}function C(w,u){const r=i.lastNonWhitespaceIndex(w);return r===-1?u:r+2}function A(w){if(w===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<w}}),J(Z[42],K([0,1,9,12,6,3,2,8,40,37,38,24]),function(O,n,E,D,i,o,m,L,a,s,_,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class h{constructor(){this.dynamicProgrammingDiffing=new a.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new _.MyersDiffAlgorithm}computeDiff(R,F,U){const P=U.maxComputationTimeMs===0?L.InfiniteTimeout.instance:new L.DateTimeout(U.maxComputationTimeMs),x=!U.ignoreTrimWhitespace,W=new Map;function $(re){let j=W.get(re);return j===void 0&&(j=W.size,W.set(re,j)),j}const I=R.map(re=>$(re.trim())),T=F.map(re=>$(re.trim())),q=new C(I,R),z=new C(T,F),t=(()=>q.length+z.length<1500?this.dynamicProgrammingDiffing.compute(q,z,P,(re,j)=>R[re]===F[j]?F[j].length===0?.1:1+Math.log(1+F[j].length):.99):this.myersDiffingAlgorithm.compute(q,z))();let se=t.diffs,ne=t.hitTimeout;se=(0,s.optimizeSequenceDiffs)(q,z,se);const ce=[],ge=re=>{if(x)for(let j=0;j<re;j++){const H=me+j,Q=_e+j;if(R[H]!==F[Q]){const G=this.refineDiff(R,F,new L.SequenceDiff(new i.OffsetRange(H,H+1),new i.OffsetRange(Q,Q+1)),P,x);for(const X of G.mappings)ce.push(X);G.hitTimeout&&(ne=!0)}}};let me=0,_e=0;for(const re of se){(0,E.assertFn)(()=>re.seq1Range.start-me===re.seq2Range.start-_e);const j=re.seq1Range.start-me;ge(j),me=re.seq1Range.endExclusive,_e=re.seq2Range.endExclusive;const H=this.refineDiff(R,F,re,P,x);H.hitTimeout&&(ne=!0);for(const Q of H.mappings)ce.push(Q)}ge(R.length-me);const ve=b(ce,R,F),Le=[];if(U.computeMoves){const re=ve.filter(H=>H.modifiedRange.isEmpty&&H.originalRange.length>=3).map(H=>new M(H.originalRange,R)),j=new Set(ve.filter(H=>H.originalRange.isEmpty&&H.modifiedRange.length>=3).map(H=>new M(H.modifiedRange,F)));for(const H of re){let Q=-1,G;for(const X of j){const te=H.computeSimilarity(X);te>Q&&(Q=te,G=X)}if(Q>.9&&G){const X=this.refineDiff(R,F,new L.SequenceDiff(new i.OffsetRange(H.range.startLineNumber-1,H.range.endLineNumberExclusive-1),new i.OffsetRange(G.range.startLineNumber-1,G.range.endLineNumberExclusive-1)),P,x),te=b(X.mappings,R,F);j.delete(G),Le.push(new e.MovedText(new e.SimpleLineRangeMapping(H.range,G.range),te))}}}return new e.LinesDiff(ve,Le,ne)}refineDiff(R,F,U,P,x){const W=new w(R,U.seq1Range,x),$=new w(F,U.seq2Range,x),I=W.length+$.length<500?this.dynamicProgrammingDiffing.compute(W,$,P):this.myersDiffingAlgorithm.compute(W,$,P);let T=I.diffs;return T=(0,s.optimizeSequenceDiffs)(W,$,T),T=d(W,$,T),T=(0,s.smoothenSequenceDiffs)(W,$,T),{mappings:T.map(z=>new e.RangeMapping(W.translateRange(z.seq1Range),$.translateRange(z.seq2Range))),hitTimeout:I.hitTimeout}}}n.StandardLinesDiffComputer=h;function d(y,R,F){const U=[];let P;function x(){if(!P)return;const $=P.s1Range.length-P.deleted,I=P.s2Range.length-P.added;Math.max(P.deleted,P.added)+(P.count-1)>$&&U.push(new L.SequenceDiff(P.s1Range,P.s2Range)),P=void 0}for(const $ of F){let I=function(se,ne){var ce,ge,me,_e;if(!P||!P.s1Range.containsRange(se)||!P.s2Range.containsRange(ne))if(P&&!(P.s1Range.endExclusive<se.start&&P.s2Range.endExclusive<ne.start)){const re=i.OffsetRange.tryCreate(P.s1Range.endExclusive,se.start),j=i.OffsetRange.tryCreate(P.s2Range.endExclusive,ne.start);P.deleted+=(ce=re?.length)!==null&&ce!==void 0?ce:0,P.added+=(ge=j?.length)!==null&&ge!==void 0?ge:0,P.s1Range=P.s1Range.join(se),P.s2Range=P.s2Range.join(ne)}else x(),P={added:0,deleted:0,count:0,s1Range:se,s2Range:ne};const ve=se.intersect($.seq1Range),Le=ne.intersect($.seq2Range);P.count++,P.deleted+=(me=ve?.length)!==null&&me!==void 0?me:0,P.added+=(_e=Le?.length)!==null&&_e!==void 0?_e:0};const T=y.findWordContaining($.seq1Range.start-1),q=R.findWordContaining($.seq2Range.start-1),z=y.findWordContaining($.seq1Range.endExclusive),t=R.findWordContaining($.seq2Range.endExclusive);T&&z&&q&&t&&T.equals(z)&&q.equals(t)?I(T,q):(T&&q&&I(T,q),z&&t&&I(z,t))}return x(),v(F,U)}function v(y,R){const F=[];for(;y.length>0||R.length>0;){const U=y[0],P=R[0];let x;U&&(!P||U.seq1Range.start<P.seq1Range.start)?x=y.shift():x=R.shift(),F.length>0&&F[F.length-1].seq1Range.endExclusive>=x.seq1Range.start?F[F.length-1]=F[F.length-1].join(x):F.push(x)}return F}function b(y,R,F){const U=[];for(const P of N(y.map(x=>p(x,R,F)),(x,W)=>x.originalRange.overlapOrTouch(W.originalRange)||x.modifiedRange.overlapOrTouch(W.modifiedRange))){const x=P[0],W=P[P.length-1];U.push(new e.LineRangeMapping(x.originalRange.join(W.originalRange),x.modifiedRange.join(W.modifiedRange),P.map($=>$.innerChanges[0])))}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(U,(P,x)=>x.originalRange.startLineNumber-P.originalRange.endLineNumberExclusive===x.modifiedRange.startLineNumber-P.modifiedRange.endLineNumberExclusive&&P.originalRange.endLineNumberExclusive<x.originalRange.startLineNumber&&P.modifiedRange.endLineNumberExclusive<x.modifiedRange.startLineNumber)),U}n.lineRangeMappingFromRangeMappings=b;function p(y,R,F){let U=0,P=0;y.modifiedRange.endColumn===1&&y.originalRange.endColumn===1&&y.originalRange.startLineNumber+U<=y.originalRange.endLineNumber&&y.modifiedRange.startLineNumber+U<=y.modifiedRange.endLineNumber&&(P=-1),y.modifiedRange.startColumn-1>=F[y.modifiedRange.startLineNumber-1].length&&y.originalRange.startColumn-1>=R[y.originalRange.startLineNumber-1].length&&y.originalRange.startLineNumber<=y.originalRange.endLineNumber+P&&y.modifiedRange.startLineNumber<=y.modifiedRange.endLineNumber+P&&(U=1);const x=new D.LineRange(y.originalRange.startLineNumber+U,y.originalRange.endLineNumber+1+P),W=new D.LineRange(y.modifiedRange.startLineNumber+U,y.modifiedRange.endLineNumber+1+P);return new e.LineRangeMapping(x,W,[y])}n.getLineRangeMapping=p;function*N(y,R){let F,U;for(const P of y)U!==void 0&&R(U,P)?F.push(P):(F&&(yield F),F=[P]),U=P;F&&(yield F)}class C{constructor(R,F){this.trimmedHash=R,this.lines=F}getElement(R){return this.trimmedHash[R]}get length(){return this.trimmedHash.length}getBoundaryScore(R){const F=R===0?0:A(this.lines[R-1]),U=R===this.lines.length?0:A(this.lines[R]);return 1e3-(F+U)}}n.LineSequence=C;function A(y){let R=0;for(;R<y.length&&(y.charCodeAt(R)===32||y.charCodeAt(R)===9);)R++;return R}class w{constructor(R,F,U){this.lines=R,this.considerWhitespaceChanges=U,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let P=!1;F.start>0&&F.endExclusive>=R.length&&(F=new i.OffsetRange(F.start-1,F.endExclusive),P=!0),this.lineRange=F;for(let x=this.lineRange.start;x<this.lineRange.endExclusive;x++){let W=R[x],$=0;if(P)$=W.length,W="",P=!1;else if(!U){const I=W.trimStart();$=W.length-I.length,W=I.trimEnd()}this.offsetByLine.push($);for(let I=0;I<W.length;I++)this.elements.push(W.charCodeAt(I));x<R.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[x-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(R=>String.fromCharCode(R)).join("")}getElement(R){return this.elements[R]}get length(){return this.elements.length}getBoundaryScore(R){const F=c(R>0?this.elements[R-1]:-1),U=c(R<this.elements.length?this.elements[R]:-1);if(F===6&&U===7)return 0;let P=0;return F!==U&&(P+=10,U===1&&(P+=1)),P+=l(F),P+=l(U),P}translateOffset(R){if(this.lineRange.isEmpty)return new o.Position(this.lineRange.start+1,1);let F=0,U=this.firstCharOffsetByLineMinusOne.length;for(;F<U;){const x=Math.floor((F+U)/2);this.firstCharOffsetByLineMinusOne[x]>R?U=x:F=x+1}const P=F===0?0:this.firstCharOffsetByLineMinusOne[F-1];return new o.Position(this.lineRange.start+F+1,R-P+1+this.offsetByLine[F])}translateRange(R){return m.Range.fromPositions(this.translateOffset(R.start),this.translateOffset(R.endExclusive))}findWordContaining(R){if(R<0||R>=this.elements.length||!u(this.elements[R]))return;let F=R;for(;F>0&&u(this.elements[F-1]);)F--;let U=R;for(;U<this.elements.length&&u(this.elements[U]);)U++;return new i.OffsetRange(F,U)}}function u(y){return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57}const r={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function l(y){return r[y]}function c(y){return y===10?7:y===13?6:f(y)?5:y>=97&&y<=122?0:y>=65&&y<=90?1:y>=48&&y<=57?2:y===-1?3:4}function f(y){return y===32||y===9}const g=new Map;function S(y){let R=g.get(y);return R===void 0&&(R=g.size,g.set(y,R)),R}class M{constructor(R,F){this.range=R,this.lines=F,this.histogram=[];let U=0;for(let P=R.startLineNumber-1;P<R.endLineNumberExclusive-1;P++){const x=F[P];for(let $=0;$<x.length;$++){U++;const I=x[$],T=S(I);this.histogram[T]=(this.histogram[T]||0)+1}U++;const W=S(`
`);this.histogram[W]=(this.histogram[W]||0)+1}this.totalCount=U}computeSimilarity(R){var F,U;let P=0;const x=Math.max(this.histogram.length,R.histogram.length);for(let W=0;W<x;W++)P+=Math.abs(((F=this.histogram[W])!==null&&F!==void 0?F:0)-((U=R.histogram[W])!==null&&U!==void 0?U:0));return 1-P/(this.totalCount+R.totalCount)}}}),J(Z[43],K([0,1,41,42]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={legacy:new E.SmartLinesDiffComputer,advanced:new D.StandardLinesDiffComputer}}),J(Z[44],K([0,1,28]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function D(h){const d=[];for(const v of h){const b=Number(v);(b||b===0&&v.replace(/\s/g,"")!=="")&&d.push(b)}return d}function i(h,d,v,b){return{red:h/255,blue:v/255,green:d/255,alpha:b}}function o(h,d){const v=d.index,b=d[0].length;if(!v)return;const p=h.positionAt(v);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:p.lineNumber,endColumn:p.column+b}}function m(h,d){if(!h)return;const v=E.Color.Format.CSS.parseHex(d);if(v)return{range:h,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function L(h,d,v){if(!h||d.length!==1)return;const p=d[0].values(),N=D(p);return{range:h,color:i(N[0],N[1],N[2],v?N[3]:1)}}function a(h,d,v){if(!h||d.length!==1)return;const p=d[0].values(),N=D(p),C=new E.Color(new E.HSLA(N[0],N[1]/100,N[2]/100,v?N[3]:1));return{range:h,color:i(C.rgba.r,C.rgba.g,C.rgba.b,C.rgba.a)}}function s(h,d){return typeof h=="string"?[...h.matchAll(d)]:h.findMatches(d)}function _(h){const d=[],b=s(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const p of b){const N=p.filter(u=>u!==void 0),C=N[1],A=N[2];if(!A)continue;let w;if(C==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;w=L(o(h,p),s(A,u),!1)}else if(C==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=L(o(h,p),s(A,u),!0)}else if(C==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;w=a(o(h,p),s(A,u),!1)}else if(C==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=a(o(h,p),s(A,u),!0)}else C==="#"&&(w=m(o(h,p),C+A));w&&d.push(w)}return d}function e(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:_(h)}n.computeDefaultDocumentColors=e}),J(Z[45],K([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(h,d,v){const b=new Uint8Array(h*d);for(let p=0,N=h*d;p<N;p++)b[p]=v;this._data=b,this.rows=h,this.cols=d}get(h,d){return this._data[h*this.cols+d]}set(h,d,v){this._data[h*this.cols+d]=v}}class i{constructor(h){let d=0,v=0;for(let p=0,N=h.length;p<N;p++){const[C,A,w]=h[p];A>d&&(d=A),C>v&&(v=C),w>v&&(v=w)}d++,v++;const b=new D(v,d,0);for(let p=0,N=h.length;p<N;p++){const[C,A,w]=h[p];b.set(C,A,w)}this._states=b,this._maxCharCode=d}nextState(h,d){return d<0||d>=this._maxCharCode?0:this._states.get(h,d)}}n.StateMachine=i;let o=null;function m(){return o===null&&(o=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o}let L=null;function a(){if(L===null){L=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<e.length;d++)L.set(e.charCodeAt(d),1);const h=".,;:";for(let d=0;d<h.length;d++)L.set(h.charCodeAt(d),2)}return L}class s{static _createLink(h,d,v,b,p){let N=p-1;do{const C=d.charCodeAt(N);if(h.get(C)!==2)break;N--}while(N>b);if(b>0){const C=d.charCodeAt(b-1),A=d.charCodeAt(N);(C===40&&A===41||C===91&&A===93||C===123&&A===125)&&N--}return{range:{startLineNumber:v,startColumn:b+1,endLineNumber:v,endColumn:N+2},url:d.substring(b,N+1)}}static computeLinks(h,d=m()){const v=a(),b=[];for(let p=1,N=h.getLineCount();p<=N;p++){const C=h.getLineContent(p),A=C.length;let w=0,u=0,r=0,l=1,c=!1,f=!1,g=!1,S=!1;for(;w<A;){let M=!1;const y=C.charCodeAt(w);if(l===13){let R;switch(y){case 40:c=!0,R=0;break;case 41:R=c?0:1;break;case 91:g=!0,f=!0,R=0;break;case 93:g=!1,R=f?0:1;break;case 123:S=!0,R=0;break;case 125:R=S?0:1;break;case 39:case 34:case 96:r===y?R=1:r===39||r===34||r===96?R=0:R=1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=g?0:1;break;default:R=v.get(y)}R===1&&(b.push(s._createLink(v,C,p,u,w)),M=!0)}else if(l===12){let R;y===91?(f=!0,R=0):R=v.get(y),R===1?M=!0:l=13}else l=d.nextState(l,y),l===0&&(M=!0);M&&(l=1,c=!1,f=!1,S=!1,u=w+1,r=y),w++}l===13&&b.push(s._createLink(v,C,p,u,A))}return b}}n.LinkComputer=s;function _(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=_}),J(Z[46],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,o,m,L,a){if(i&&o){const s=this.doNavigateValueSet(o,a);if(s)return{range:i,value:s}}if(m&&L){const s=this.doNavigateValueSet(L,a);if(s)return{range:m,value:s}}return null}doNavigateValueSet(i,o){const m=this.numberReplace(i,o);return m!==null?m:this.textReplace(i,o)}numberReplace(i,o){const m=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let L=Number(i);const a=parseFloat(i);return!isNaN(L)&&!isNaN(a)&&L===a?L===0&&!o?null:(L=Math.floor(L*m),L+=o?m:-m,String(L/m)):null}textReplace(i,o){return this.valueSetsReplace(this._defaultValueSet,i,o)}valueSetsReplace(i,o,m){let L=null;for(let a=0,s=i.length;L===null&&a<s;a++)L=this.valueSetReplace(i[a],o,m);return L}valueSetReplace(i,o,m){let L=i.indexOf(o);return L>=0?(L+=m?1:-1,L<0?L=i.length-1:L%=i.length,i[L]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),J(Z[47],K([0,1,11]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var D;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var i;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var o;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(o||(n.MinimapPosition=o={}));var m;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(m||(n.InjectedTextCursorStops=m={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,b.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!b.insertSpaces,this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=!!b.trimAutoWhitespace,this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this._indentSizeIsTabSize===b._indentSizeIsTabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=L;class a{constructor(b,p){this._findMatchBrand=void 0,this.range=b,this.matches=p}}n.FindMatch=a;function s(v){return v&&typeof v.read=="function"}n.isITextSnapshot=s;class _{constructor(b,p,N,C,A,w){this.identifier=b,this.range=p,this.text=N,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=A,this._isTracked=w}}n.ValidAnnotatedEditOperation=_;class e{constructor(b,p,N){this.regex=b,this.wordSeparators=p,this.simpleSearch=N}}n.SearchData=e;class h{constructor(b,p,N){this.reverseEdits=b,this.changes=p,this.trimAutoWhitespaceLineNumbers=N}}n.ApplyEditsResult=h;function d(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}n.shouldSynchronizeModel=d}),J(Z[48],K([0,1,26,21]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(a,s){a=(0,D.toUint32)(a);const _=this.values,e=this.prefixSum,h=s.length;return h===0?!1:(this.values=new Uint32Array(_.length+h),this.values.set(_.subarray(0,a),0),this.values.set(_.subarray(a),a+h),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,D.toUint32)(a),s=(0,D.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,D.toUint32)(a),s=(0,D.toUint32)(s);const _=this.values,e=this.prefixSum;if(a>=_.length)return!1;const h=_.length-a;return s>=h&&(s=h),s===0?!1:(this.values=new Uint32Array(_.length-s),this.values.set(_.subarray(0,a),0),this.values.set(_.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,D.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let _=s;_<=a;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,_=this.values.length-1,e=0,h=0,d=0;for(;s<=_;)if(e=s+(_-s)/2|0,h=this.prefixSum[e],d=h-this.values[e],a<d)_=e-1;else if(a>=h)s=e+1;else break;return new m(e,a-d)}}n.PrefixSumComputer=i;class o{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],_=s>0?this._prefixSum[s-1]:0;return new m(s,a-_)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,E.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const _=this._values[a],e=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=e+_;for(let h=0;h<_;h++)this._indexBySum[e+h]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=o;class m{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}n.PrefixSumIndexOfResult=m}),J(Z[49],K([0,1,5,3,48]),function(O,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(L,a,s,_){this._uri=L,this._lines=a,this._eol=s,this._versionId=_,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(L){L.eol&&L.eol!==this._eol&&(this._eol=L.eol,this._lineStarts=null);const a=L.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new D.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=L.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const L=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let _=0;_<a;_++)s[_]=this._lines[_].length+L;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(L,a){this._lines[L]=a,this._lineStarts&&this._lineStarts.setValue(L,this._lines[L].length+this._eol.length)}_acceptDeleteRange(L){if(L.startLineNumber===L.endLineNumber){if(L.startColumn===L.endColumn)return;this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.startLineNumber-1].substring(L.endColumn-1));return}this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.endLineNumber-1].substring(L.endColumn-1)),this._lines.splice(L.startLineNumber,L.endLineNumber-L.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(L.startLineNumber,L.endLineNumber-L.startLineNumber)}_acceptInsertText(L,a){if(a.length===0)return;const s=(0,E.splitLines)(a);if(s.length===1){this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+s[0]+this._lines[L.lineNumber-1].substring(L.column-1));return}s[s.length-1]+=this._lines[L.lineNumber-1].substring(L.column-1),this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+s[0]);const _=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(L.lineNumber+e-1,0,s[e]),_[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(L.lineNumber,_)}}n.MirrorTextModel=o}),J(Z[50],K([0,1,5,36,3,2,47]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const L=999;class a{constructor(C,A,w,u){this.searchString=C,this.isRegex=A,this.matchCase=w,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let C;this.isRegex?C=s(this.searchString):C=this.searchString.indexOf(`
`)>=0;let A=null;try{A=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:C,global:!0,unicode:!0})}catch{return null}if(!A)return null;let w=!this.isRegex&&!C;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new m.SearchData(A,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,w?this.searchString:null)}}n.SearchParams=a;function s(N){if(!N||N.length===0)return!1;for(let C=0,A=N.length;C<A;C++){const w=N.charCodeAt(C);if(w===10)return!0;if(w===92){if(C++,C>=A)break;const u=N.charCodeAt(C);if(u===110||u===114||u===87)return!0}}return!1}n.isMultilineRegexSource=s;function _(N,C,A){if(!A)return new m.FindMatch(N,null);const w=[];for(let u=0,r=C.length;u<r;u++)w[u]=C[u];return new m.FindMatch(N,w)}n.createFindMatch=_;class e{constructor(C){const A=[];let w=0;for(let u=0,r=C.length;u<r;u++)C.charCodeAt(u)===10&&(A[w++]=u);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(C){const A=this._lineFeedsOffsets;let w=0,u=A.length-1;if(u===-1||C<=A[0])return 0;for(;w<u;){const r=w+((u-w)/2>>0);A[r]>=C?u=r-1:A[r+1]>=C?(w=r,u=r):w=r+1}return w+1}}class h{static findMatches(C,A,w,u,r){const l=A.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(C,w,new p(l.wordSeparators,l.regex),u,r):this._doFindMatchesLineByLine(C,w,l,u,r):[]}static _getMultilineMatchRange(C,A,w,u,r,l){let c,f=0;u?(f=u.findLineFeedCountBeforeOffset(r),c=A+r+f):c=A+r;let g;if(u){const R=u.findLineFeedCountBeforeOffset(r+l.length)-f;g=c+l.length+R}else g=c+l.length;const S=C.getPositionAt(c),M=C.getPositionAt(g);return new o.Range(S.lineNumber,S.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(C,A,w,u,r){const l=C.getOffsetAt(A.getStartPosition()),c=C.getValueInRange(A,1),f=C.getEOL()===`\r
`?new e(c):null,g=[];let S=0,M;for(w.reset(0);M=w.next(c);)if(g[S++]=_(this._getMultilineMatchRange(C,l,c,f,M.index,M[0]),M,u),S>=r)return g;return g}static _doFindMatchesLineByLine(C,A,w,u,r){const l=[];let c=0;if(A.startLineNumber===A.endLineNumber){const g=C.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return c=this._findMatchesInLine(w,g,A.startLineNumber,A.startColumn-1,c,l,u,r),l}const f=C.getLineContent(A.startLineNumber).substring(A.startColumn-1);c=this._findMatchesInLine(w,f,A.startLineNumber,A.startColumn-1,c,l,u,r);for(let g=A.startLineNumber+1;g<A.endLineNumber&&c<r;g++)c=this._findMatchesInLine(w,C.getLineContent(g),g,0,c,l,u,r);if(c<r){const g=C.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);c=this._findMatchesInLine(w,g,A.endLineNumber,0,c,l,u,r)}return l}static _findMatchesInLine(C,A,w,u,r,l,c,f){const g=C.wordSeparators;if(!c&&C.simpleSearch){const y=C.simpleSearch,R=y.length,F=A.length;let U=-R;for(;(U=A.indexOf(y,U+R))!==-1;)if((!g||b(g,A,F,U,R))&&(l[r++]=new m.FindMatch(new o.Range(w,U+1+u,w,U+1+R+u),null),r>=f))return r;return r}const S=new p(C.wordSeparators,C.regex);let M;S.reset(0);do if(M=S.next(A),M&&(l[r++]=_(new o.Range(w,M.index+1+u,w,M.index+1+M[0].length+u),M,c),r>=f))return r;while(M);return r}static findNextMatch(C,A,w,u){const r=A.parseSearchRequest();if(!r)return null;const l=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(C,w,l,u):this._doFindNextMatchLineByLine(C,w,l,u)}static _doFindNextMatchMultiline(C,A,w,u){const r=new i.Position(A.lineNumber,1),l=C.getOffsetAt(r),c=C.getLineCount(),f=C.getValueInRange(new o.Range(r.lineNumber,r.column,c,C.getLineMaxColumn(c)),1),g=C.getEOL()===`\r
`?new e(f):null;w.reset(A.column-1);const S=w.next(f);return S?_(this._getMultilineMatchRange(C,l,f,g,S.index,S[0]),S,u):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(C,new i.Position(1,1),w,u):null}static _doFindNextMatchLineByLine(C,A,w,u){const r=C.getLineCount(),l=A.lineNumber,c=C.getLineContent(l),f=this._findFirstMatchInLine(w,c,l,A.column,u);if(f)return f;for(let g=1;g<=r;g++){const S=(l+g-1)%r,M=C.getLineContent(S+1),y=this._findFirstMatchInLine(w,M,S+1,1,u);if(y)return y}return null}static _findFirstMatchInLine(C,A,w,u,r){C.reset(u-1);const l=C.next(A);return l?_(new o.Range(w,l.index+1,w,l.index+1+l[0].length),l,r):null}static findPreviousMatch(C,A,w,u){const r=A.parseSearchRequest();if(!r)return null;const l=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(C,w,l,u):this._doFindPreviousMatchLineByLine(C,w,l,u)}static _doFindPreviousMatchMultiline(C,A,w,u){const r=this._doFindMatchesMultiline(C,new o.Range(1,1,A.lineNumber,A.column),w,u,10*L);if(r.length>0)return r[r.length-1];const l=C.getLineCount();return A.lineNumber!==l||A.column!==C.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(C,new i.Position(l,C.getLineMaxColumn(l)),w,u):null}static _doFindPreviousMatchLineByLine(C,A,w,u){const r=C.getLineCount(),l=A.lineNumber,c=C.getLineContent(l).substring(0,A.column-1),f=this._findLastMatchInLine(w,c,l,u);if(f)return f;for(let g=1;g<=r;g++){const S=(r+l-g-1)%r,M=C.getLineContent(S+1),y=this._findLastMatchInLine(w,M,S+1,u);if(y)return y}return null}static _findLastMatchInLine(C,A,w,u){let r=null,l;for(C.reset(0);l=C.next(A);)r=_(new o.Range(w,l.index+1,w,l.index+1+l[0].length),l,u);return r}}n.TextModelSearch=h;function d(N,C,A,w,u){if(w===0)return!0;const r=C.charCodeAt(w-1);if(N.get(r)!==0||r===13||r===10)return!0;if(u>0){const l=C.charCodeAt(w);if(N.get(l)!==0)return!0}return!1}function v(N,C,A,w,u){if(w+u===A)return!0;const r=C.charCodeAt(w+u);if(N.get(r)!==0||r===13||r===10)return!0;if(u>0){const l=C.charCodeAt(w+u-1);if(N.get(l)!==0)return!0}return!1}function b(N,C,A,w,u){return d(N,C,A,w,u)&&v(N,C,A,w,u)}n.isValidMatch=b;class p{constructor(C,A){this._wordSeparators=C,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(C){this._searchRegex.lastIndex=C,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(C){const A=C.length;let w;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(w=this._searchRegex.exec(C),!w))return null;const u=w.index,r=w[0].length;if(u===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(C,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,C,A,u,r))return w}while(w);return null}}n.Searcher=p}),J(Z[51],K([0,1,2,50,5,9,23]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class L{static computeUnicodeHighlights(h,d,v){const b=v?v.startLineNumber:1,p=v?v.endLineNumber:h.getLineCount(),N=new s(d),C=N.getCandidateCodePoints();let A;C==="allNonBasicAscii"?A=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):A=new RegExp(`${a(Array.from(C))}`,"g");const w=new D.Searcher(null,A),u=[];let r=!1,l,c=0,f=0,g=0;e:for(let S=b,M=p;S<=M;S++){const y=h.getLineContent(S),R=y.length;w.reset(0);do if(l=w.next(y),l){let F=l.index,U=l.index+l[0].length;if(F>0){const $=y.charCodeAt(F-1);i.isHighSurrogate($)&&F--}if(U+1<R){const $=y.charCodeAt(U-1);i.isHighSurrogate($)&&U++}const P=y.substring(F,U);let x=(0,m.getWordAtText)(F+1,m.DEFAULT_WORD_REGEXP,y,0);x&&x.endColumn<=F+1&&(x=null);const W=N.shouldHighlightNonBasicASCII(P,x?x.word:null);if(W!==0){W===3?c++:W===2?f++:W===1?g++:(0,o.assertNever)(W);const $=1e3;if(u.length>=$){r=!0;break e}u.push(new E.Range(S,F+1,S,U+1))}}while(l)}return{ranges:u,hasMore:r,ambiguousCharacterCount:c,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:g}}static computeUnicodeHighlightReason(h,d){const v=new s(d);switch(v.shouldHighlightNonBasicASCII(h,null)){case 0:return null;case 2:return{kind:1};case 3:{const p=h.codePointAt(0),N=v.ambiguousCharacters.getPrimaryConfusable(p),C=i.AmbiguousCharacters.getLocales().filter(A=>!i.AmbiguousCharacters.getInstance(new Set([...d.allowedLocales,A])).isAmbiguous(p));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:C}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=L;function a(e,h){return`[${i.escapeRegExpCharacters(e.map(v=>String.fromCodePoint(v)).join(""))}]`}class s{constructor(h){this.options=h,this.allowedCodePoints=new Set(h.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(h.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const h=new Set;if(this.options.invisibleCharacters)for(const d of i.InvisibleCharacters.codePoints)_(String.fromCodePoint(d))||h.add(d);if(this.options.ambiguousCharacters)for(const d of this.ambiguousCharacters.getConfusableCodePoints())h.add(d);for(const d of this.allowedCodePoints)h.delete(d);return h}shouldHighlightNonBasicASCII(h,d){const v=h.codePointAt(0);if(this.allowedCodePoints.has(v))return 0;if(this.options.nonBasicASCII)return 1;let b=!1,p=!1;if(d)for(const N of d){const C=N.codePointAt(0),A=i.isBasicASCII(N);b=b||A,!A&&!this.ambiguousCharacters.isAmbiguous(C)&&!i.InvisibleCharacters.isInvisibleCharacter(C)&&(p=!0)}return!b&&p?0:this.options.invisibleCharacters&&!_(h)&&i.InvisibleCharacters.isInvisibleCharacter(v)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(v)?3:0}}function _(e){return e===" "||e===`
`||e==="	"}}),J(Z[52],K([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E||(n.AccessibilitySupport=E={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D||(n.CodeActionTriggerType=D={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var o;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(o||(n.CompletionItemKind=o={}));var m;(function(t){t[t.Deprecated=1]="Deprecated"})(m||(n.CompletionItemTag=m={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(n.CompletionTriggerKind=L={}));var a;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(a||(n.ContentWidgetPositionPreference=a={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var _;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(_||(n.DefaultEndOfLine=_={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var h;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(h||(n.EditorAutoIndentStrategy=h={}));var d;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=7]="autoClosingDelete",t[t.autoClosingOvertype=8]="autoClosingOvertype",t[t.autoClosingQuotes=9]="autoClosingQuotes",t[t.autoIndent=10]="autoIndent",t[t.automaticLayout=11]="automaticLayout",t[t.autoSurround=12]="autoSurround",t[t.bracketPairColorization=13]="bracketPairColorization",t[t.guides=14]="guides",t[t.codeLens=15]="codeLens",t[t.codeLensFontFamily=16]="codeLensFontFamily",t[t.codeLensFontSize=17]="codeLensFontSize",t[t.colorDecorators=18]="colorDecorators",t[t.colorDecoratorsLimit=19]="colorDecoratorsLimit",t[t.columnSelection=20]="columnSelection",t[t.comments=21]="comments",t[t.contextmenu=22]="contextmenu",t[t.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",t[t.cursorBlinking=24]="cursorBlinking",t[t.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",t[t.cursorStyle=26]="cursorStyle",t[t.cursorSurroundingLines=27]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",t[t.cursorWidth=29]="cursorWidth",t[t.disableLayerHinting=30]="disableLayerHinting",t[t.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",t[t.domReadOnly=32]="domReadOnly",t[t.dragAndDrop=33]="dragAndDrop",t[t.dropIntoEditor=34]="dropIntoEditor",t[t.emptySelectionClipboard=35]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",t[t.extraEditorClassName=37]="extraEditorClassName",t[t.fastScrollSensitivity=38]="fastScrollSensitivity",t[t.find=39]="find",t[t.fixedOverflowWidgets=40]="fixedOverflowWidgets",t[t.folding=41]="folding",t[t.foldingStrategy=42]="foldingStrategy",t[t.foldingHighlight=43]="foldingHighlight",t[t.foldingImportsByDefault=44]="foldingImportsByDefault",t[t.foldingMaximumRegions=45]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=47]="fontFamily",t[t.fontInfo=48]="fontInfo",t[t.fontLigatures=49]="fontLigatures",t[t.fontSize=50]="fontSize",t[t.fontWeight=51]="fontWeight",t[t.fontVariations=52]="fontVariations",t[t.formatOnPaste=53]="formatOnPaste",t[t.formatOnType=54]="formatOnType",t[t.glyphMargin=55]="glyphMargin",t[t.gotoLocation=56]="gotoLocation",t[t.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",t[t.hover=58]="hover",t[t.inDiffEditor=59]="inDiffEditor",t[t.inlineSuggest=60]="inlineSuggest",t[t.letterSpacing=61]="letterSpacing",t[t.lightbulb=62]="lightbulb",t[t.lineDecorationsWidth=63]="lineDecorationsWidth",t[t.lineHeight=64]="lineHeight",t[t.lineNumbers=65]="lineNumbers",t[t.lineNumbersMinChars=66]="lineNumbersMinChars",t[t.linkedEditing=67]="linkedEditing",t[t.links=68]="links",t[t.matchBrackets=69]="matchBrackets",t[t.minimap=70]="minimap",t[t.mouseStyle=71]="mouseStyle",t[t.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=73]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",t[t.multiCursorModifier=75]="multiCursorModifier",t[t.multiCursorPaste=76]="multiCursorPaste",t[t.multiCursorLimit=77]="multiCursorLimit",t[t.occurrencesHighlight=78]="occurrencesHighlight",t[t.overviewRulerBorder=79]="overviewRulerBorder",t[t.overviewRulerLanes=80]="overviewRulerLanes",t[t.padding=81]="padding",t[t.pasteAs=82]="pasteAs",t[t.parameterHints=83]="parameterHints",t[t.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",t[t.quickSuggestions=86]="quickSuggestions",t[t.quickSuggestionsDelay=87]="quickSuggestionsDelay",t[t.readOnly=88]="readOnly",t[t.renameOnType=89]="renameOnType",t[t.renderControlCharacters=90]="renderControlCharacters",t[t.renderFinalNewline=91]="renderFinalNewline",t[t.renderLineHighlight=92]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=94]="renderValidationDecorations",t[t.renderWhitespace=95]="renderWhitespace",t[t.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",t[t.roundedSelection=97]="roundedSelection",t[t.rulers=98]="rulers",t[t.scrollbar=99]="scrollbar",t[t.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=101]="scrollBeyondLastLine",t[t.scrollPredominantAxis=102]="scrollPredominantAxis",t[t.selectionClipboard=103]="selectionClipboard",t[t.selectionHighlight=104]="selectionHighlight",t[t.selectOnLineNumbers=105]="selectOnLineNumbers",t[t.showFoldingControls=106]="showFoldingControls",t[t.showUnused=107]="showUnused",t[t.snippetSuggestions=108]="snippetSuggestions",t[t.smartSelect=109]="smartSelect",t[t.smoothScrolling=110]="smoothScrolling",t[t.stickyScroll=111]="stickyScroll",t[t.stickyTabStops=112]="stickyTabStops",t[t.stopRenderingLineAfter=113]="stopRenderingLineAfter",t[t.suggest=114]="suggest",t[t.suggestFontSize=115]="suggestFontSize",t[t.suggestLineHeight=116]="suggestLineHeight",t[t.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",t[t.suggestSelection=118]="suggestSelection",t[t.tabCompletion=119]="tabCompletion",t[t.tabIndex=120]="tabIndex",t[t.unicodeHighlighting=121]="unicodeHighlighting",t[t.unusualLineTerminators=122]="unusualLineTerminators",t[t.useShadowDOM=123]="useShadowDOM",t[t.useTabStops=124]="useTabStops",t[t.wordBreak=125]="wordBreak",t[t.wordSeparators=126]="wordSeparators",t[t.wordWrap=127]="wordWrap",t[t.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=130]="wordWrapColumn",t[t.wordWrapOverride1=131]="wordWrapOverride1",t[t.wordWrapOverride2=132]="wordWrapOverride2",t[t.wrappingIndent=133]="wrappingIndent",t[t.wrappingStrategy=134]="wrappingStrategy",t[t.showDeprecated=135]="showDeprecated",t[t.inlayHints=136]="inlayHints",t[t.editorClassName=137]="editorClassName",t[t.pixelRatio=138]="pixelRatio",t[t.tabFocusMode=139]="tabFocusMode",t[t.layoutInfo=140]="layoutInfo",t[t.wrappingInfo=141]="wrappingInfo",t[t.defaultColorDecorators=142]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=143]="colorDecoratorsActivatedOn"})(d||(n.EditorOption=d={}));var v;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(n.EndOfLinePreference=v={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b||(n.EndOfLineSequence=b={}));var p;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(p||(n.GlyphMarginLane=p={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N||(n.IndentAction=N={}));var C;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(C||(n.InjectedTextCursorStops=C={}));var A;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(A||(n.InlayHintKind=A={}));var w;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(w||(n.InlineCompletionTriggerKind=w={}));var u;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(u||(n.KeyCode=u={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var l;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(l||(n.MarkerTag=l={}));var c;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(c||(n.MinimapPosition=c={}));var f;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(n.MouseTargetType=f={}));var g;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(g||(n.OverlayWidgetPositionPreference=g={}));var S;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(S||(n.OverviewRulerLane=S={}));var M;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(M||(n.PositionAffinity=M={}));var y;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(y||(n.RenderLineNumbersType=y={}));var R;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(R||(n.RenderMinimap=R={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var U;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(U||(n.ScrollbarVisibility=U={}));var P;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(P||(n.SelectionDirection=P={}));var x;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(x||(n.SignatureHelpTriggerKind=x={}));var W;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(W||(n.SymbolKind=W={}));var $;(function(t){t[t.Deprecated=1]="Deprecated"})($||(n.SymbolTag=$={}));var I;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(I||(n.TextEditorCursorBlinkingStyle=I={}));var T;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(T||(n.TextEditorCursorStyle=T={}));var q;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(q||(n.TrackedRangeStickiness=q={}));var z;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(z||(n.WrappingIndent=z={}))}),J(Z[53],K([0,1,7,10]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(L){this._onDidChange.fire({changedLanguages:L,changedColorMap:!1})}register(L,a){return this._tokenizationSupports.set(L,a),this.handleChange([L]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(L)===a&&(this._tokenizationSupports.delete(L),this.handleChange([L]))})}get(L){return this._tokenizationSupports.get(L)||null}registerFactory(L,a){var s;(s=this._factories.get(L))===null||s===void 0||s.dispose();const _=new o(this,L,a);return this._factories.set(L,_),(0,D.toDisposable)(()=>{const e=this._factories.get(L);!e||e!==_||(this._factories.delete(L),e.dispose())})}getOrCreate(L){return de(this,void 0,void 0,function*(){const a=this.get(L);if(a)return a;const s=this._factories.get(L);return!s||s.isResolved?null:(yield s.resolve(),this.get(L))})}isResolved(L){if(this.get(L))return!0;const s=this._factories.get(L);return!!(!s||s.isResolved)}setColorMap(L){this._colorMap=L,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class o extends D.Disposable{get isResolved(){return this._isResolved}constructor(L,a,s){super(),this._registry=L,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return de(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return de(this,void 0,void 0,function*(){const L=yield this._factory.tokenizationSupport;this._isResolved=!0,L&&!this._isDisposed&&this._register(this._registry.register(this._languageId,L))})}}}),J(Z[54],K([25,59]),function(O,n){return O.create("vs/base/common/platform",n)}),J(Z[13],K([0,1,54]),function(O,n,E){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,o=!1,m=!1,L=!1,a=!1,s=!1,_=!1,e=!1,h=!1,d=!1,v,b=n.LANGUAGE_DEFAULT,p=n.LANGUAGE_DEFAULT,N,C;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let A;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?A=n.globals.vscode.process:typeof process<"u"&&(A=process);const w=typeof((D=A?.versions)===null||D===void 0?void 0:D.electron)=="string",u=w&&A?.type==="renderer";if(typeof navigator=="object"&&!u)C=navigator.userAgent,i=C.indexOf("Windows")>=0,o=C.indexOf("Macintosh")>=0,e=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=C.indexOf("Linux")>=0,d=C?.indexOf("Mobi")>=0,s=!0,v=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,b=v,p=navigator.language;else if(typeof A=="object"){i=A.platform==="win32",o=A.platform==="darwin",m=A.platform==="linux",L=m&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,_=w,h=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=n.LANGUAGE_DEFAULT,b=n.LANGUAGE_DEFAULT;const g=A.env.VSCODE_NLS_CONFIG;if(g)try{const S=JSON.parse(g),M=S.availableLanguages["*"];v=S.locale,p=S.osLocale,b=M||n.LANGUAGE_DEFAULT,N=S._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");let r=0;o?r=1:i?r=3:m&&(r=2),n.isWindows=i,n.isMacintosh=o,n.isLinux=m,n.isNative=a,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=d,n.userAgent=C,n.language=b,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const g=[];n.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let y=0,R=g.length;y<R;y++){const F=g[y];if(F.id===M.data.vscodeScheduleAsyncWork){g.splice(y,1),F.callback();return}}});let S=0;return M=>{const y=++S;g.push({id:y,callback:M}),n.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return g=>setTimeout(g)})(),n.OS=o||e?2:i?1:3;let l=!0,c=!1;function f(){if(!c){c=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,l=new Uint16Array(g.buffer)[0]===(2<<8)+1}return l}n.isLittleEndian=f,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),J(Z[55],K([0,1,13]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),J(Z[56],K([0,1,55]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,o=90,m=122,L=46,a=47,s=92,_=58,e=63;class h extends Error{constructor(l,c,f){let g;typeof c=="string"&&c.indexOf("not ")===0?(g="must not be",c=c.replace(/^not /,"")):g="must be";const S=l.indexOf(".")!==-1?"property":"argument";let M=`The "${l}" ${S} ${g} of type ${c}`;M+=`. Received type ${typeof f}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,l){if(r===null||typeof r!="object")throw new h(l,"Object",r)}function v(r,l){if(typeof r!="string")throw new h(l,"string",r)}const b=E.platform==="win32";function p(r){return r===a||r===s}function N(r){return r===a}function C(r){return r>=D&&r<=o||r>=i&&r<=m}function A(r,l,c,f){let g="",S=0,M=-1,y=0,R=0;for(let F=0;F<=r.length;++F){if(F<r.length)R=r.charCodeAt(F);else{if(f(R))break;R=a}if(f(R)){if(!(M===F-1||y===1))if(y===2){if(g.length<2||S!==2||g.charCodeAt(g.length-1)!==L||g.charCodeAt(g.length-2)!==L){if(g.length>2){const U=g.lastIndexOf(c);U===-1?(g="",S=0):(g=g.slice(0,U),S=g.length-1-g.lastIndexOf(c)),M=F,y=0;continue}else if(g.length!==0){g="",S=0,M=F,y=0;continue}}l&&(g+=g.length>0?`${c}..`:"..",S=2)}else g.length>0?g+=`${c}${r.slice(M+1,F)}`:g=r.slice(M+1,F),S=F-M-1;M=F,y=0}else R===L&&y!==-1?++y:y=-1}return g}function w(r,l){d(l,"pathObject");const c=l.dir||l.root,f=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${f}`:`${c}${r}${f}`:f}n.win32={resolve(...r){let l="",c="",f=!1;for(let g=r.length-1;g>=-1;g--){let S;if(g>=0){if(S=r[g],v(S,"path"),S.length===0)continue}else l.length===0?S=E.cwd():(S=E.env[`=${l}`]||E.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==l.toLowerCase()&&S.charCodeAt(2)===s)&&(S=`${l}\\`));const M=S.length;let y=0,R="",F=!1;const U=S.charCodeAt(0);if(M===1)p(U)&&(y=1,F=!0);else if(p(U))if(F=!0,p(S.charCodeAt(1))){let P=2,x=P;for(;P<M&&!p(S.charCodeAt(P));)P++;if(P<M&&P!==x){const W=S.slice(x,P);for(x=P;P<M&&p(S.charCodeAt(P));)P++;if(P<M&&P!==x){for(x=P;P<M&&!p(S.charCodeAt(P));)P++;(P===M||P!==x)&&(R=`\\\\${W}\\${S.slice(x,P)}`,y=P)}}}else y=1;else C(U)&&S.charCodeAt(1)===_&&(R=S.slice(0,2),y=2,M>2&&p(S.charCodeAt(2))&&(F=!0,y=3));if(R.length>0)if(l.length>0){if(R.toLowerCase()!==l.toLowerCase())continue}else l=R;if(f){if(l.length>0)break}else if(c=`${S.slice(y)}\\${c}`,f=F,F&&l.length>0)break}return c=A(c,!f,"\\",p),f?`${l}\\${c}`:`${l}${c}`||"."},normalize(r){v(r,"path");const l=r.length;if(l===0)return".";let c=0,f,g=!1;const S=r.charCodeAt(0);if(l===1)return N(S)?"\\":r;if(p(S))if(g=!0,p(r.charCodeAt(1))){let y=2,R=y;for(;y<l&&!p(r.charCodeAt(y));)y++;if(y<l&&y!==R){const F=r.slice(R,y);for(R=y;y<l&&p(r.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&!p(r.charCodeAt(y));)y++;if(y===l)return`\\\\${F}\\${r.slice(R)}\\`;y!==R&&(f=`\\\\${F}\\${r.slice(R,y)}`,c=y)}}}else c=1;else C(S)&&r.charCodeAt(1)===_&&(f=r.slice(0,2),c=2,l>2&&p(r.charCodeAt(2))&&(g=!0,c=3));let M=c<l?A(r.slice(c),!g,"\\",p):"";return M.length===0&&!g&&(M="."),M.length>0&&p(r.charCodeAt(l-1))&&(M+="\\"),f===void 0?g?`\\${M}`:M:g?`${f}\\${M}`:`${f}${M}`},isAbsolute(r){v(r,"path");const l=r.length;if(l===0)return!1;const c=r.charCodeAt(0);return p(c)||l>2&&C(c)&&r.charCodeAt(1)===_&&p(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,c;for(let S=0;S<r.length;++S){const M=r[S];v(M,"path"),M.length>0&&(l===void 0?l=c=M:l+=`\\${M}`)}if(l===void 0)return".";let f=!0,g=0;if(typeof c=="string"&&p(c.charCodeAt(0))){++g;const S=c.length;S>1&&p(c.charCodeAt(1))&&(++g,S>2&&(p(c.charCodeAt(2))?++g:f=!1))}if(f){for(;g<l.length&&p(l.charCodeAt(g));)g++;g>=2&&(l=`\\${l.slice(g)}`)}return n.win32.normalize(l)},relative(r,l){if(v(r,"from"),v(l,"to"),r===l)return"";const c=n.win32.resolve(r),f=n.win32.resolve(l);if(c===f||(r=c.toLowerCase(),l=f.toLowerCase(),r===l))return"";let g=0;for(;g<r.length&&r.charCodeAt(g)===s;)g++;let S=r.length;for(;S-1>g&&r.charCodeAt(S-1)===s;)S--;const M=S-g;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let R=l.length;for(;R-1>y&&l.charCodeAt(R-1)===s;)R--;const F=R-y,U=M<F?M:F;let P=-1,x=0;for(;x<U;x++){const $=r.charCodeAt(g+x);if($!==l.charCodeAt(y+x))break;$===s&&(P=x)}if(x!==U){if(P===-1)return f}else{if(F>U){if(l.charCodeAt(y+x)===s)return f.slice(y+x+1);if(x===2)return f.slice(y+x)}M>U&&(r.charCodeAt(g+x)===s?P=x:x===2&&(P=3)),P===-1&&(P=0)}let W="";for(x=g+P+1;x<=S;++x)(x===S||r.charCodeAt(x)===s)&&(W+=W.length===0?"..":"\\..");return y+=P,W.length>0?`${W}${f.slice(y,R)}`:(f.charCodeAt(y)===s&&++y,f.slice(y,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=n.win32.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const c=l.charCodeAt(2);if(c!==e&&c!==L)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(C(l.charCodeAt(0))&&l.charCodeAt(1)===_&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return r},dirname(r){v(r,"path");const l=r.length;if(l===0)return".";let c=-1,f=0;const g=r.charCodeAt(0);if(l===1)return p(g)?r:".";if(p(g)){if(c=f=1,p(r.charCodeAt(1))){let y=2,R=y;for(;y<l&&!p(r.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&p(r.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&!p(r.charCodeAt(y));)y++;if(y===l)return r;y!==R&&(c=f=y+1)}}}}else C(g)&&r.charCodeAt(1)===_&&(c=l>2&&p(r.charCodeAt(2))?3:2,f=c);let S=-1,M=!0;for(let y=l-1;y>=f;--y)if(p(r.charCodeAt(y))){if(!M){S=y;break}}else M=!1;if(S===-1){if(c===-1)return".";S=c}return r.slice(0,S)},basename(r,l){l!==void 0&&v(l,"ext"),v(r,"path");let c=0,f=-1,g=!0,S;if(r.length>=2&&C(r.charCodeAt(0))&&r.charCodeAt(1)===_&&(c=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let M=l.length-1,y=-1;for(S=r.length-1;S>=c;--S){const R=r.charCodeAt(S);if(p(R)){if(!g){c=S+1;break}}else y===-1&&(g=!1,y=S+1),M>=0&&(R===l.charCodeAt(M)?--M===-1&&(f=S):(M=-1,f=y))}return c===f?f=y:f===-1&&(f=r.length),r.slice(c,f)}for(S=r.length-1;S>=c;--S)if(p(r.charCodeAt(S))){if(!g){c=S+1;break}}else f===-1&&(g=!1,f=S+1);return f===-1?"":r.slice(c,f)},extname(r){v(r,"path");let l=0,c=-1,f=0,g=-1,S=!0,M=0;r.length>=2&&r.charCodeAt(1)===_&&C(r.charCodeAt(0))&&(l=f=2);for(let y=r.length-1;y>=l;--y){const R=r.charCodeAt(y);if(p(R)){if(!S){f=y+1;break}continue}g===-1&&(S=!1,g=y+1),R===L?c===-1?c=y:M!==1&&(M=1):c!==-1&&(M=-1)}return c===-1||g===-1||M===0||M===1&&c===g-1&&c===f+1?"":r.slice(c,g)},format:w.bind(null,"\\"),parse(r){v(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const c=r.length;let f=0,g=r.charCodeAt(0);if(c===1)return p(g)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(p(g)){if(f=1,p(r.charCodeAt(1))){let P=2,x=P;for(;P<c&&!p(r.charCodeAt(P));)P++;if(P<c&&P!==x){for(x=P;P<c&&p(r.charCodeAt(P));)P++;if(P<c&&P!==x){for(x=P;P<c&&!p(r.charCodeAt(P));)P++;P===c?f=P:P!==x&&(f=P+1)}}}}else if(C(g)&&r.charCodeAt(1)===_){if(c<=2)return l.root=l.dir=r,l;if(f=2,p(r.charCodeAt(2))){if(c===3)return l.root=l.dir=r,l;f=3}}f>0&&(l.root=r.slice(0,f));let S=-1,M=f,y=-1,R=!0,F=r.length-1,U=0;for(;F>=f;--F){if(g=r.charCodeAt(F),p(g)){if(!R){M=F+1;break}continue}y===-1&&(R=!1,y=F+1),g===L?S===-1?S=F:U!==1&&(U=1):S!==-1&&(U=-1)}return y!==-1&&(S===-1||U===0||U===1&&S===y-1&&S===M+1?l.base=l.name=r.slice(M,y):(l.name=r.slice(M,S),l.base=r.slice(M,y),l.ext=r.slice(S,y))),M>0&&M!==f?l.dir=r.slice(0,M-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(b){const r=/\\/g;return()=>{const l=E.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let l="",c=!1;for(let f=r.length-1;f>=-1&&!c;f--){const g=f>=0?r[f]:u();v(g,"path"),g.length!==0&&(l=`${g}/${l}`,c=g.charCodeAt(0)===a)}return l=A(l,!c,"/",N),c?`/${l}`:l.length>0?l:"."},normalize(r){if(v(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,c=r.charCodeAt(r.length-1)===a;return r=A(r,!l,"/",N),r.length===0?l?"/":c?"./":".":(c&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return v(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let c=0;c<r.length;++c){const f=r[c];v(f,"path"),f.length>0&&(l===void 0?l=f:l+=`/${f}`)}return l===void 0?".":n.posix.normalize(l)},relative(r,l){if(v(r,"from"),v(l,"to"),r===l||(r=n.posix.resolve(r),l=n.posix.resolve(l),r===l))return"";const c=1,f=r.length,g=f-c,S=1,M=l.length-S,y=g<M?g:M;let R=-1,F=0;for(;F<y;F++){const P=r.charCodeAt(c+F);if(P!==l.charCodeAt(S+F))break;P===a&&(R=F)}if(F===y)if(M>y){if(l.charCodeAt(S+F)===a)return l.slice(S+F+1);if(F===0)return l.slice(S+F)}else g>y&&(r.charCodeAt(c+F)===a?R=F:F===0&&(R=0));let U="";for(F=c+R+1;F<=f;++F)(F===f||r.charCodeAt(F)===a)&&(U+=U.length===0?"..":"/..");return`${U}${l.slice(S+R)}`},toNamespacedPath(r){return r},dirname(r){if(v(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let c=-1,f=!0;for(let g=r.length-1;g>=1;--g)if(r.charCodeAt(g)===a){if(!f){c=g;break}}else f=!1;return c===-1?l?"/":".":l&&c===1?"//":r.slice(0,c)},basename(r,l){l!==void 0&&v(l,"ext"),v(r,"path");let c=0,f=-1,g=!0,S;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let M=l.length-1,y=-1;for(S=r.length-1;S>=0;--S){const R=r.charCodeAt(S);if(R===a){if(!g){c=S+1;break}}else y===-1&&(g=!1,y=S+1),M>=0&&(R===l.charCodeAt(M)?--M===-1&&(f=S):(M=-1,f=y))}return c===f?f=y:f===-1&&(f=r.length),r.slice(c,f)}for(S=r.length-1;S>=0;--S)if(r.charCodeAt(S)===a){if(!g){c=S+1;break}}else f===-1&&(g=!1,f=S+1);return f===-1?"":r.slice(c,f)},extname(r){v(r,"path");let l=-1,c=0,f=-1,g=!0,S=0;for(let M=r.length-1;M>=0;--M){const y=r.charCodeAt(M);if(y===a){if(!g){c=M+1;break}continue}f===-1&&(g=!1,f=M+1),y===L?l===-1?l=M:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||f===-1||S===0||S===1&&l===f-1&&l===c+1?"":r.slice(l,f)},format:w.bind(null,"/"),parse(r){v(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const c=r.charCodeAt(0)===a;let f;c?(l.root="/",f=1):f=0;let g=-1,S=0,M=-1,y=!0,R=r.length-1,F=0;for(;R>=f;--R){const U=r.charCodeAt(R);if(U===a){if(!y){S=R+1;break}continue}M===-1&&(y=!1,M=R+1),U===L?g===-1?g=R:F!==1&&(F=1):g!==-1&&(F=-1)}if(M!==-1){const U=S===0&&c?1:S;g===-1||F===0||F===1&&g===M-1&&g===S+1?l.base=l.name=r.slice(U,M):(l.name=r.slice(U,g),l.base=r.slice(U,M),l.ext=r.slice(g,M))}return S>0?l.dir=r.slice(0,S-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=b?n.win32.normalize:n.posix.normalize,n.resolve=b?n.win32.resolve:n.posix.resolve,n.relative=b?n.win32.relative:n.posix.relative,n.dirname=b?n.win32.dirname:n.posix.dirname,n.basename=b?n.win32.basename:n.posix.basename,n.extname=b?n.win32.extname:n.posix.extname,n.sep=b?n.win32.sep:n.posix.sep}),J(Z[14],K([0,1,56,13]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,m=/^\/\//;function L(c,f){if(!c.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!i.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!o.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(c,f){return!c&&!f?"file":c}function s(c,f){switch(c){case"https":case"http":case"file":f?f[0]!==e&&(f=e+f):f=e;break}return f}const _="",e="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(f){return f instanceof d?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,g,S,M,y,R=!1){typeof f=="object"?(this.scheme=f.scheme||_,this.authority=f.authority||_,this.path=f.path||_,this.query=f.query||_,this.fragment=f.fragment||_):(this.scheme=a(f,R),this.authority=g||_,this.path=s(this.scheme,S||_),this.query=M||_,this.fragment=y||_,L(this,R))}get fsPath(){return A(this,!1)}with(f){if(!f)return this;let{scheme:g,authority:S,path:M,query:y,fragment:R}=f;return g===void 0?g=this.scheme:g===null&&(g=_),S===void 0?S=this.authority:S===null&&(S=_),M===void 0?M=this.path:M===null&&(M=_),y===void 0?y=this.query:y===null&&(y=_),R===void 0?R=this.fragment:R===null&&(R=_),g===this.scheme&&S===this.authority&&M===this.path&&y===this.query&&R===this.fragment?this:new b(g,S,M,y,R)}static parse(f,g=!1){const S=h.exec(f);return S?new b(S[2]||_,l(S[4]||_),l(S[5]||_),l(S[7]||_),l(S[9]||_),g):new b(_,_,_,_,_)}static file(f){let g=_;if(D.isWindows&&(f=f.replace(/\\/g,e)),f[0]===e&&f[1]===e){const S=f.indexOf(e,2);S===-1?(g=f.substring(2),f=e):(g=f.substring(2,S),f=f.substring(S)||e)}return new b("file",g,f,_,_)}static from(f,g){return new b(f.scheme,f.authority,f.path,f.query,f.fragment,g)}static joinPath(f,...g){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return D.isWindows&&f.scheme==="file"?S=d.file(E.win32.join(A(f,!0),...g)).path:S=E.posix.join(f.path,...g),f.with({path:S})}toString(f=!1){return w(this,f)}toJSON(){return this}static revive(f){var g,S;if(f){if(f instanceof d)return f;{const M=new b(f);return M._formatted=(g=f.external)!==null&&g!==void 0?g:null,M._fsPath=f._sep===v&&(S=f.fsPath)!==null&&S!==void 0?S:null,M}}else return f}}n.URI=d;const v=D.isWindows?1:void 0;class b extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=A(this,!1)),this._fsPath}toString(f=!1){return f?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=v),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(c,f,g){let S,M=-1;for(let y=0;y<c.length;y++){const R=c.charCodeAt(y);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||f&&R===47||g&&R===91||g&&R===93||g&&R===58)M!==-1&&(S+=encodeURIComponent(c.substring(M,y)),M=-1),S!==void 0&&(S+=c.charAt(y));else{S===void 0&&(S=c.substr(0,y));const F=p[R];F!==void 0?(M!==-1&&(S+=encodeURIComponent(c.substring(M,y)),M=-1),S+=F):M===-1&&(M=y)}}return M!==-1&&(S+=encodeURIComponent(c.substring(M))),S!==void 0?S:c}function C(c){let f;for(let g=0;g<c.length;g++){const S=c.charCodeAt(g);S===35||S===63?(f===void 0&&(f=c.substr(0,g)),f+=p[S]):f!==void 0&&(f+=c[g])}return f!==void 0?f:c}function A(c,f){let g;return c.authority&&c.path.length>1&&c.scheme==="file"?g=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?f?g=c.path.substr(1):g=c.path[1].toLowerCase()+c.path.substr(2):g=c.path,D.isWindows&&(g=g.replace(/\//g,"\\")),g}n.uriToFsPath=A;function w(c,f){const g=f?C:N;let S="",{scheme:M,authority:y,path:R,query:F,fragment:U}=c;if(M&&(S+=M,S+=":"),(y||M==="file")&&(S+=e,S+=e),y){let P=y.indexOf("@");if(P!==-1){const x=y.substr(0,P);y=y.substr(P+1),P=x.lastIndexOf(":"),P===-1?S+=g(x,!1,!1):(S+=g(x.substr(0,P),!1,!1),S+=":",S+=g(x.substr(P+1),!1,!0)),S+="@"}y=y.toLowerCase(),P=y.lastIndexOf(":"),P===-1?S+=g(y,!1,!0):(S+=g(y.substr(0,P),!1,!0),S+=y.substr(P))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const P=R.charCodeAt(1);P>=65&&P<=90&&(R=`/${String.fromCharCode(P+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const P=R.charCodeAt(0);P>=65&&P<=90&&(R=`${String.fromCharCode(P+32)}:${R.substr(2)}`)}S+=g(R,!0,!1)}return F&&(S+="?",S+=g(F,!1,!1)),U&&(S+="#",S+=f?U:N(U,!1,!1)),S}function u(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+u(c.substr(3)):c}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(c){return c.match(r)?c.replace(r,f=>u(f)):c}}),J(Z[60],K([0,1,4,7,10,11,13,5]),function(O,n,E,D,i,o,m,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function _(l){m.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}n.logOnceWebWorkerWarning=_;class e{constructor(c,f,g,S){this.vsWorker=c,this.req=f,this.method=g,this.args=S,this.type=0}}class h{constructor(c,f,g,S){this.vsWorker=c,this.seq=f,this.res=g,this.err=S,this.type=1}}class d{constructor(c,f,g,S){this.vsWorker=c,this.req=f,this.eventName=g,this.arg=S,this.type=2}}class v{constructor(c,f,g){this.vsWorker=c,this.req=f,this.event=g,this.type=3}}class b{constructor(c,f){this.vsWorker=c,this.req=f,this.type=4}}class p{constructor(c){this._workerId=-1,this._handler=c,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(c){this._workerId=c}sendMessage(c,f){const g=String(++this._lastSentReq);return new Promise((S,M)=>{this._pendingReplies[g]={resolve:S,reject:M},this._send(new e(this._workerId,g,c,f))})}listen(c,f){let g=null;const S=new D.Emitter({onWillAddFirstListener:()=>{g=String(++this._lastSentReq),this._pendingEmitters.set(g,S),this._send(new d(this._workerId,g,c,f))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(g),this._send(new b(this._workerId,g)),g=null}});return S.event}handleMessage(c){!c||!c.vsWorker||this._workerId!==-1&&c.vsWorker!==this._workerId||this._handleMessage(c)}_handleMessage(c){switch(c.type){case 1:return this._handleReplyMessage(c);case 0:return this._handleRequestMessage(c);case 2:return this._handleSubscribeEventMessage(c);case 3:return this._handleEventMessage(c);case 4:return this._handleUnsubscribeEventMessage(c)}}_handleReplyMessage(c){if(!this._pendingReplies[c.seq]){console.warn("Got reply to unknown seq");return}const f=this._pendingReplies[c.seq];if(delete this._pendingReplies[c.seq],c.err){let g=c.err;c.err.$isError&&(g=new Error,g.name=c.err.name,g.message=c.err.message,g.stack=c.err.stack),f.reject(g);return}f.resolve(c.res)}_handleRequestMessage(c){const f=c.req;this._handler.handleMessage(c.method,c.args).then(S=>{this._send(new h(this._workerId,f,S,void 0))},S=>{S.detail instanceof Error&&(S.detail=(0,E.transformErrorForSerialization)(S.detail)),this._send(new h(this._workerId,f,void 0,(0,E.transformErrorForSerialization)(S)))})}_handleSubscribeEventMessage(c){const f=c.req,g=this._handler.handleEvent(c.eventName,c.arg)(S=>{this._send(new v(this._workerId,f,S))});this._pendingEvents.set(f,g)}_handleEventMessage(c){if(!this._pendingEmitters.has(c.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(c.req).fire(c.event)}_handleUnsubscribeEventMessage(c){if(!this._pendingEvents.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(c.req).dispose(),this._pendingEvents.delete(c.req)}_send(c){const f=[];if(c.type===0)for(let g=0;g<c.args.length;g++)c.args[g]instanceof ArrayBuffer&&f.push(c.args[g]);else c.type===1&&c.res instanceof ArrayBuffer&&f.push(c.res);this._handler.sendMessage(c,f)}}class N extends i.Disposable{constructor(c,f,g){super();let S=null;this._worker=this._register(c.create("vs/base/common/worker/simpleWorker",P=>{this._protocol.handleMessage(P)},P=>{S?.(P)})),this._protocol=new p({sendMessage:(P,x)=>{this._worker.postMessage(P,x)},handleMessage:(P,x)=>{if(typeof g[P]!="function")return Promise.reject(new Error("Missing method "+P+" on main thread host."));try{return Promise.resolve(g[P].apply(g,x))}catch(W){return Promise.reject(W)}},handleEvent:(P,x)=>{if(A(P)){const W=g[P].call(g,x);if(typeof W!="function")throw new Error(`Missing dynamic event ${P} on main thread host.`);return W}if(C(P)){const W=g[P];if(typeof W!="function")throw new Error(`Missing event ${P} on main thread host.`);return W}throw new Error(`Malformed event name ${P}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?M=y.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const R=(0,o.getAllMethodNames)(g);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(M)),f,R]);const F=(P,x)=>this._request(P,x),U=(P,x)=>this._protocol.listen(P,x);this._lazyProxy=new Promise((P,x)=>{S=x,this._onModuleLoaded.then(W=>{P(w(W,F,U))},W=>{x(W),this._onError("Worker failed to load "+f,W)})})}getProxyObject(){return this._lazyProxy}_request(c,f){return new Promise((g,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(c,f).then(g,S)},S)})}_onError(c,f){console.error(c),console.info(f)}}n.SimpleWorkerClient=N;function C(l){return l[0]==="o"&&l[1]==="n"&&L.isUpperAsciiLetter(l.charCodeAt(2))}function A(l){return/^onDynamic/.test(l)&&L.isUpperAsciiLetter(l.charCodeAt(9))}function w(l,c,f){const g=y=>function(){const R=Array.prototype.slice.call(arguments,0);return c(y,R)},S=y=>function(R){return f(y,R)},M={};for(const y of l){if(A(y)){M[y]=S(y);continue}if(C(y)){M[y]=f(y,void 0);continue}M[y]=g(y)}return M}class u{constructor(c,f){this._requestHandlerFactory=f,this._requestHandler=null,this._protocol=new p({sendMessage:(g,S)=>{c(g,S)},handleMessage:(g,S)=>this._handleMessage(g,S),handleEvent:(g,S)=>this._handleEvent(g,S)})}onmessage(c){this._protocol.handleMessage(c)}_handleMessage(c,f){if(c===a)return this.initialize(f[0],f[1],f[2],f[3]);if(!this._requestHandler||typeof this._requestHandler[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this._requestHandler[c].apply(this._requestHandler,f))}catch(g){return Promise.reject(g)}}_handleEvent(c,f){if(!this._requestHandler)throw new Error("Missing requestHandler");if(A(c)){const g=this._requestHandler[c].call(this._requestHandler,f);if(typeof g!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return g}if(C(c)){const g=this._requestHandler[c];if(typeof g!="function")throw new Error(`Missing event ${c} on request handler.`);return g}throw new Error(`Malformed event name ${c}`)}initialize(c,f,g,S){this._protocol.setWorkerId(c);const R=w(S,(F,U)=>this._protocol.sendMessage(F,U),(F,U)=>this._protocol.listen(F,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve((0,o.getAllMethodNames)(this._requestHandler))):(f&&(typeof f.baseUrl<"u"&&delete f.baseUrl,typeof f.paths<"u"&&typeof f.paths.vs<"u"&&delete f.paths.vs,typeof f.trustedTypesPolicy!==void 0&&delete f.trustedTypesPolicy,f.catchError=!0,globalThis.require.config(f)),new Promise((F,U)=>{(globalThis.require||O)([g],x=>{if(this._requestHandler=x.create(R),!this._requestHandler){U(new Error("No RequestHandler!"));return}F((0,o.getAllMethodNames)(this._requestHandler))},U)}))}}n.SimpleWorkerServer=u;function r(l){return new u(l,null)}n.create=r}),J(Z[57],K([0,1,34,14,2,53]),function(O,n,E,D,i,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class m{constructor(u,r,l){this.offset=u,this.type=r,this.language=l,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=m;class L{constructor(u,r){this.tokens=u,this.endState=r,this._tokenizationResultBrand=void 0}}n.TokenizationResult=L;class a{constructor(u,r){this.tokens=u,this.endState=r,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var s;(function(w){const u=new Map;u.set(0,E.Codicon.symbolMethod),u.set(1,E.Codicon.symbolFunction),u.set(2,E.Codicon.symbolConstructor),u.set(3,E.Codicon.symbolField),u.set(4,E.Codicon.symbolVariable),u.set(5,E.Codicon.symbolClass),u.set(6,E.Codicon.symbolStruct),u.set(7,E.Codicon.symbolInterface),u.set(8,E.Codicon.symbolModule),u.set(9,E.Codicon.symbolProperty),u.set(10,E.Codicon.symbolEvent),u.set(11,E.Codicon.symbolOperator),u.set(12,E.Codicon.symbolUnit),u.set(13,E.Codicon.symbolValue),u.set(15,E.Codicon.symbolEnum),u.set(14,E.Codicon.symbolConstant),u.set(15,E.Codicon.symbolEnum),u.set(16,E.Codicon.symbolEnumMember),u.set(17,E.Codicon.symbolKeyword),u.set(27,E.Codicon.symbolSnippet),u.set(18,E.Codicon.symbolText),u.set(19,E.Codicon.symbolColor),u.set(20,E.Codicon.symbolFile),u.set(21,E.Codicon.symbolReference),u.set(22,E.Codicon.symbolCustomColor),u.set(23,E.Codicon.symbolFolder),u.set(24,E.Codicon.symbolTypeParameter),u.set(25,E.Codicon.account),u.set(26,E.Codicon.issues);function r(f){let g=u.get(f);return g||(console.info("No codicon found for CompletionItemKind "+f),g=E.Codicon.symbolProperty),g}w.toIcon=r;const l=new Map;l.set("method",0),l.set("function",1),l.set("constructor",2),l.set("field",3),l.set("variable",4),l.set("class",5),l.set("struct",6),l.set("interface",7),l.set("module",8),l.set("property",9),l.set("event",10),l.set("operator",11),l.set("unit",12),l.set("value",13),l.set("constant",14),l.set("enum",15),l.set("enum-member",16),l.set("enumMember",16),l.set("keyword",17),l.set("snippet",27),l.set("text",18),l.set("color",19),l.set("file",20),l.set("reference",21),l.set("customcolor",22),l.set("folder",23),l.set("type-parameter",24),l.set("typeParameter",24),l.set("account",25),l.set("issue",26);function c(f,g){let S=l.get(f);return typeof S>"u"&&!g&&(S=9),S}w.fromString=c})(s||(n.CompletionItemKinds=s={}));var _;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(_||(n.InlineCompletionTriggerKind=_={}));class e{constructor(u,r,l,c){this.range=u,this.text=r,this.completionKind=l,this.isSnippetText=c}equals(u){return i.Range.lift(this.range).equalsRange(u.range)&&this.text===u.text&&this.completionKind===u.completionKind&&this.isSnippetText===u.isSnippetText}}n.SelectedSuggestionInfo=e;var h;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(h||(n.SignatureHelpTriggerKind=h={}));var d;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(d||(n.DocumentHighlightKind=d={}));function v(w){return w&&D.URI.isUri(w.uri)&&i.Range.isIRange(w.range)&&(i.Range.isIRange(w.originSelectionRange)||i.Range.isIRange(w.targetSelectionRange))}n.isLocationLink=v;var b;(function(w){const u=new Map;u.set(0,E.Codicon.symbolFile),u.set(1,E.Codicon.symbolModule),u.set(2,E.Codicon.symbolNamespace),u.set(3,E.Codicon.symbolPackage),u.set(4,E.Codicon.symbolClass),u.set(5,E.Codicon.symbolMethod),u.set(6,E.Codicon.symbolProperty),u.set(7,E.Codicon.symbolField),u.set(8,E.Codicon.symbolConstructor),u.set(9,E.Codicon.symbolEnum),u.set(10,E.Codicon.symbolInterface),u.set(11,E.Codicon.symbolFunction),u.set(12,E.Codicon.symbolVariable),u.set(13,E.Codicon.symbolConstant),u.set(14,E.Codicon.symbolString),u.set(15,E.Codicon.symbolNumber),u.set(16,E.Codicon.symbolBoolean),u.set(17,E.Codicon.symbolArray),u.set(18,E.Codicon.symbolObject),u.set(19,E.Codicon.symbolKey),u.set(20,E.Codicon.symbolNull),u.set(21,E.Codicon.symbolEnumMember),u.set(22,E.Codicon.symbolStruct),u.set(23,E.Codicon.symbolEvent),u.set(24,E.Codicon.symbolOperator),u.set(25,E.Codicon.symbolTypeParameter);function r(l){let c=u.get(l);return c||(console.info("No codicon found for SymbolKind "+l),c=E.Codicon.symbolProperty),c}w.toIcon=r})(b||(n.SymbolKinds=b={}));class p{static fromValue(u){switch(u){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(u)}constructor(u){this.value=u}}n.FoldingRangeKind=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var N;(function(w){function u(r){return!r||typeof r!="object"?!1:typeof r.id=="string"&&typeof r.title=="string"}w.is=u})(N||(n.Command=N={}));var C;(function(w){w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(C||(n.InlayHintKind=C={}));class A{constructor(u){this.createSupport=u,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(u=>{u&&u.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=A,n.TokenizationRegistry=new o.TokenizationRegistry}),J(Z[58],K([0,1,32,7,30,14,3,2,35,57,52]),function(O,n,E,D,i,o,m,L,a,s,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(v,b){return(0,i.KeyChord)(v,b)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:D.Emitter,KeyCode:_.KeyCode,KeyMod:e,Position:m.Position,Range:L.Range,Selection:a.Selection,SelectionDirection:_.SelectionDirection,MarkerSeverity:_.MarkerSeverity,MarkerTag:_.MarkerTag,Uri:o.URI,Token:s.Token}}n.createMonacoBaseAPI=h}),J(Z[61],K([0,1,19,14,3,2,49,23,45,46,58,18,51,43,11,44]),function(O,n,E,D,i,o,m,L,a,s,_,e,h,d,v,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class p extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(w){const u=[];for(let r=0;r<this._lines.length;r++){const l=this._lines[r],c=this.offsetAt(new i.Position(r+1,1)),f=l.matchAll(w);for(const g of f)(g.index||g.index===0)&&(g.index=g.index+c),u.push(g)}return u}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(w){return this._lines[w-1]}getWordAtPosition(w,u){const r=(0,L.getWordAtText)(w.column,(0,L.ensureValidWordDefinition)(u),this._lines[w.lineNumber-1],0);return r?new o.Range(w.lineNumber,r.startColumn,w.lineNumber,r.endColumn):null}words(w){const u=this._lines,r=this._wordenize.bind(this);let l=0,c="",f=0,g=[];return{*[Symbol.iterator](){for(;;)if(f<g.length){const S=c.substring(g[f].start,g[f].end);f+=1,yield S}else if(l<u.length)c=u[l],g=r(c,w),f=0,l+=1;else break}}}getLineWords(w,u){const r=this._lines[w-1],l=this._wordenize(r,u),c=[];for(const f of l)c.push({word:r.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return c}_wordenize(w,u){const r=[];let l;for(u.lastIndex=0;(l=u.exec(w))&&l[0].length!==0;)r.push({start:l.index,end:l.index+l[0].length});return r}getValueInRange(w){if(w=this._validateRange(w),w.startLineNumber===w.endLineNumber)return this._lines[w.startLineNumber-1].substring(w.startColumn-1,w.endColumn-1);const u=this._eol,r=w.startLineNumber-1,l=w.endLineNumber-1,c=[];c.push(this._lines[r].substring(w.startColumn-1));for(let f=r+1;f<l;f++)c.push(this._lines[f]);return c.push(this._lines[l].substring(0,w.endColumn-1)),c.join(u)}offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.lineNumber-2)+(w.column-1)}positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(w),r=this._lines[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,r)}}_validateRange(w){const u=this._validatePosition({lineNumber:w.startLineNumber,column:w.startColumn}),r=this._validatePosition({lineNumber:w.endLineNumber,column:w.endColumn});return u.lineNumber!==w.startLineNumber||u.column!==w.startColumn||r.lineNumber!==w.endLineNumber||r.column!==w.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:r.lineNumber,endColumn:r.column}:w}_validatePosition(w){if(!i.Position.isIPosition(w))throw new Error("bad position");let{lineNumber:u,column:r}=w,l=!1;if(u<1)u=1,r=1,l=!0;else if(u>this._lines.length)u=this._lines.length,r=this._lines[u-1].length+1,l=!0;else{const c=this._lines[u-1].length+1;r<1?(r=1,l=!0):r>c&&(r=c,l=!0)}return l?{lineNumber:u,column:r}:w}}class N{constructor(w,u){this._host=w,this._models=Object.create(null),this._foreignModuleFactory=u,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(w){return this._models[w]}_getModels(){const w=[];return Object.keys(this._models).forEach(u=>w.push(this._models[u])),w}acceptNewModel(w){this._models[w.url]=new p(D.URI.parse(w.url),w.lines,w.EOL,w.versionId)}acceptModelChanged(w,u){if(!this._models[w])return;this._models[w].onEvents(u)}acceptRemovedModel(w){this._models[w]&&delete this._models[w]}computeUnicodeHighlights(w,u,r){return de(this,void 0,void 0,function*(){const l=this._getModel(w);return l?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(l,u,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(w,u,r,l){return de(this,void 0,void 0,function*(){const c=this._getModel(w),f=this._getModel(u);return!c||!f?null:N.computeDiff(c,f,r,l)})}static computeDiff(w,u,r,l){const c=l==="advanced"?d.linesDiffComputers.advanced:d.linesDiffComputers.legacy,f=w.getLinesContent(),g=u.getLinesContent(),S=c.computeDiff(f,g,r),M=S.changes.length>0?!1:this._modelsAreIdentical(w,u);function y(R){return R.map(F=>{var U;return[F.originalRange.startLineNumber,F.originalRange.endLineNumberExclusive,F.modifiedRange.startLineNumber,F.modifiedRange.endLineNumberExclusive,(U=F.innerChanges)===null||U===void 0?void 0:U.map(P=>[P.originalRange.startLineNumber,P.originalRange.startColumn,P.originalRange.endLineNumber,P.originalRange.endColumn,P.modifiedRange.startLineNumber,P.modifiedRange.startColumn,P.modifiedRange.endLineNumber,P.modifiedRange.endColumn])]})}return{identical:M,quitEarly:S.hitTimeout,changes:y(S.changes),moves:S.moves.map(R=>[R.lineRangeMapping.originalRange.startLineNumber,R.lineRangeMapping.originalRange.endLineNumberExclusive,R.lineRangeMapping.modifiedRange.startLineNumber,R.lineRangeMapping.modifiedRange.endLineNumberExclusive,y(R.changes)])}}static _modelsAreIdentical(w,u){const r=w.getLineCount(),l=u.getLineCount();if(r!==l)return!1;for(let c=1;c<=r;c++){const f=w.getLineContent(c),g=u.getLineContent(c);if(f!==g)return!1}return!0}computeMoreMinimalEdits(w,u,r){return de(this,void 0,void 0,function*(){const l=this._getModel(w);if(!l)return u;const c=[];let f;u=u.slice(0).sort((g,S)=>{if(g.range&&S.range)return o.Range.compareRangesUsingStarts(g.range,S.range);const M=g.range?0:1,y=S.range?0:1;return M-y});for(let{range:g,text:S,eol:M}of u){if(typeof M=="number"&&(f=M),o.Range.isEmpty(g)&&!S)continue;const y=l.getValueInRange(g);if(S=S.replace(/\r\n|\n|\r/g,l.eol),y===S)continue;if(Math.max(S.length,y.length)>N._diffLimit){c.push({range:g,text:S});continue}const R=(0,E.stringDiff)(y,S,r),F=l.offsetAt(o.Range.lift(g).getStartPosition());for(const U of R){const P=l.positionAt(F+U.originalStart),x=l.positionAt(F+U.originalStart+U.originalLength),W={text:S.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:x.lineNumber,endColumn:x.column}};l.getValueInRange(W.range)!==W.text&&c.push(W)}}return typeof f=="number"&&c.push({eol:f,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),c})}computeLinks(w){return de(this,void 0,void 0,function*(){const u=this._getModel(w);return u?(0,a.computeLinks)(u):null})}computeDefaultDocumentColors(w){return de(this,void 0,void 0,function*(){const u=this._getModel(w);return u?(0,b.computeDefaultDocumentColors)(u):null})}textualSuggest(w,u,r,l){return de(this,void 0,void 0,function*(){const c=new e.StopWatch,f=new RegExp(r,l),g=new Set;e:for(const S of w){const M=this._getModel(S);if(M){for(const y of M.words(f))if(!(y===u||!isNaN(Number(y)))&&(g.add(y),g.size>N._suggestionsLimit))break e}}return{words:Array.from(g),duration:c.elapsed()}})}computeWordRanges(w,u,r,l){return de(this,void 0,void 0,function*(){const c=this._getModel(w);if(!c)return Object.create(null);const f=new RegExp(r,l),g=Object.create(null);for(let S=u.startLineNumber;S<u.endLineNumber;S++){const M=c.getLineWords(S,f);for(const y of M){if(!isNaN(Number(y.word)))continue;let R=g[y.word];R||(R=[],g[y.word]=R),R.push({startLineNumber:S,startColumn:y.startColumn,endLineNumber:S,endColumn:y.endColumn})}}return g})}navigateValueSet(w,u,r,l,c){return de(this,void 0,void 0,function*(){const f=this._getModel(w);if(!f)return null;const g=new RegExp(l,c);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const S=f.getValueInRange(u),M=f.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},g);if(!M)return null;const y=f.getValueInRange(M);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(u,S,M,y,r)})}loadForeignModule(w,u,r){const l=(g,S)=>this._host.fhr(g,S),f={host:(0,v.createProxyObject)(r,l),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(f,u),Promise.resolve((0,v.getAllMethodNames)(this._foreignModule))):new Promise((g,S)=>{O([w],M=>{this._foreignModule=M.create(f,u),g((0,v.getAllMethodNames)(this._foreignModule))},S)})}fmr(w,u){if(!this._foreignModule||typeof this._foreignModule[w]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+w));try{return Promise.resolve(this._foreignModule[w].apply(this._foreignModule,u))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function C(A){return new N(A,null)}n.create=C,typeof importScripts=="function"&&(globalThis.monaco=(0,_.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map